﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Stage;
	import flash.geom.ColorTransform;
	import flash.geom.Rectangle;
	
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	import flash.text.Font;
	import flash.text.AntiAliasType;
	import flash.utils.getDefinitionByName;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	public class CraftSticks extends MovieClip
	{
		var stick1Counter:Number=0;
		var stick10Counter:Number=0;
		var stick100Counter:Number=0;
		var clipcnt:Number=0;
		var clipArray:Array=new Array();
		var CounterText_mc:MovieClip=new MovieClip();
		var TotalCounter:Number=0;
		var selectedClip:MovieClip=new MovieClip();
		var TF:TextFormat=new TextFormat();
		public function CraftSticks()
		{
			AddScreenContents();
		} 
		private function AddScreenContents():void
		{
			AddStickControls();
			AddGroupControls();	
			AddCounterControls();
			AddCounterText();
			AddResetBtn();
		}
		private function AddStickControls():void
		{
			var AC:StickBoard=new StickBoard(); 
			AC.mc_1.addEventListener(MouseEvent.CLICK,AddStick);
			AC.mc_10.addEventListener(MouseEvent.CLICK,AddStick);
			AC.mc_100.addEventListener(MouseEvent.CLICK,AddStick);
			AC.mc_100.visible=false;
			AC.x=317.9;
			AC.y=473.12;
			addChild(AC);			
		}
		private function AddGroupControls():void
		{
			var Con:Controls=new Controls();
			Con.name="controls";
			DisableBtn(Con.BT);
			DisableBtn(Con.BA);
			DisableBtn(Con.RE);
			Con.BA.addEventListener(MouseEvent.CLICK,Break);
			Con.RE.addEventListener(MouseEvent.CLICK,Remove);
			Con.BT.addEventListener(MouseEvent.CLICK,Bundle);
			Con.x=851.4;
			Con.y=460.9;
			addChild(Con);
		}
		private function AddCounterControls():void
		{
			var CB:CounterBoard=new CounterBoard();
			CB.name="CB";
			CB.hideCounterBtn.visible=false;
			CB.showCounterBtn.addEventListener(MouseEvent.CLICK,showCounter);
			CB.hideCounterBtn.addEventListener(MouseEvent.CLICK,hideCounter);
			CB.x=282.8;
			CB.y=431.4;
			addChild(CB);
		}
		private function AddResetBtn():void
		{
			var reset_btn:ResetBtn=new ResetBtn();
			reset_btn.name ="reset_btn"
			reset_btn.addEventListener(MouseEvent.CLICK, Reset);
			reset_btn.x = -100
			reset_btn.y = -200
			addChild(reset_btn);
		}
		private function AddCounterText():void
		{
			var sh:Shape=new Shape();
			sh.graphics.lineStyle(1,0x000000,1);
			sh.graphics.beginFill(0xffffff);
			sh.graphics.drawRect(0,0,75,30);
			sh.graphics.endFill();
			addChild(sh);
			
			CounterText_mc.addChild(sh);
			
			CounterText_mc.visible=false;
			
			var TxtFld:TextField=new TextField();
			//TxtFld.autoSize="left";
			TxtFld.selectable=false;
			TxtFld.multiline=false;
			
			TxtFld.htmlText=""+TotalCounter;
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			TF=new TextFormat();
			TF.align=TextFormatAlign.CENTER;
			
			var FontC=getDefinitionByName("PMMaths") as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=20;
			TF.color=0x000000;

			TxtFld.setTextFormat(TF);	
			TxtFld.embedFonts=true;
			CounterText_mc.addChild(TxtFld);
			
			CounterText_mc.x=650;
			CounterText_mc.y=10;
			
			TxtFld.x=(CounterText_mc.width-TxtFld.width)/2;
			TxtFld.width=75;
			TxtFld.y=(CounterText_mc.height-TxtFld.height)/2;
			
			TxtFld.name="txt";
			addChild(CounterText_mc);
			
		}
		private function AddStick(e:MouseEvent):void
		{
			var target=e.target;
			var targetName:String=e.target.name;	
			var Num:Number=Number(targetName.split("_")[1]);
			
			var cname=getDefinitionByName(targetName) as Class;
			var mc:MovieClip=new MovieClip();
			mc.id=clipcnt;
			mc.groupid=Num;
			
			RemoveExistingHilights();
			
			
			clipArray.push([clipcnt,mc,Num]);
			clipcnt++;
			var stick=new cname();
			var sh:Shape=new Shape();
			sh.name="sh";
			sh.graphics.beginFill(0x99CCFF);
			sh.graphics.drawRect(-5,-5,stick.width+10,stick.height+10);
			sh.graphics.endFill();
			mc.addChild(sh);
			mc.addChild(stick);
			mc.mouseChildren=false;
			/*mc.x=mouseX;
			mc.y=mouseY-50;*/
			mc.x=380-(mc.width/2);
			mc.y=230-(mc.height/2);
			addChild(mc);
			mc.name="mc_"+mc.id;
			mc.buttonMode=true;
			mc.addEventListener(MouseEvent.MOUSE_DOWN,dragMe);
			selectedClip=mc;
			
			switch(Num)
			{
				case 1:
					stick1Counter++;
					break;
				case 10:
					stick10Counter+=1;
					break;
				case 100:
					stick100Counter+=1;
					break;
				default:
					break;
			}			
			TotalCount();
			var Con=getChildByName("controls");
			//EnableBtn(Con.BA);
			EnableBtn(Con.RE);
			var c:Number=CheckSameGroups();
		}
		private function TotalCount():void
		{
			TotalCounter=stick1Counter+(stick10Counter*10)+(stick100Counter*100);
			ChangeCounterText();
		}
		private function ChangeCounterText():void
		{
			TextField(CounterText_mc.getChildByName("txt")).htmlText=""+TotalCounter;
			TextField(CounterText_mc.getChildByName("txt")).setTextFormat(TF);	
			TextField(CounterText_mc.getChildByName("txt")).embedFonts=true;
		}
		private function RemoveExistingHilights():void{
			for(var i=0;i<clipArray.length;i++)
			{
				var mclip=clipArray[i][1];
				(mclip.getChildByName("sh")).visible=false;
			}
		}
		private function dragMe(e:MouseEvent):void
		{		
			var currentMovie=e.target;
			selectedClip=currentMovie;
			RemoveExistingHilights();
			(selectedClip.getChildByName("sh")).visible=true;
			currentMovie.startDrag(false,new Rectangle(0,0,760-currentMovie.width,530-currentMovie.width));
			setChildIndex(currentMovie,numChildren-1);
			currentMovie.addEventListener(MouseEvent.MOUSE_UP,dropMe);
			stage.addEventListener(MouseEvent.MOUSE_UP,dropMe);
			var c:Number=CheckSameGroups();
			//trace(c);
			var Con=getChildByName("controls");
			//trace("GANEsh = "+e.currentTarget.groupid);
			if(e.currentTarget.groupid == 10){
				EnableBtn(Con.BA);
			}else{
				DisableBtn(Con.BA);
			}
			EnableBtn(Con.RE);
			
		}
		private function CheckSameGroups():Number
		{
			var counter:Number=0;
			for(var i:int=0;i<clipArray.length;i++)
			{
				if(clipArray[i][2]==selectedClip.groupid)
				{
					counter++;
				}
			}
			//if(counter>=10 && selectedClip.groupid<100)
			if(counter>=10 && selectedClip.groupid<10)
			{
				var Con=getChildByName("controls");
				EnableBtn(Con.BT);
			}
			return counter;
		}
		private function dropMe(e:MouseEvent):void
		{
			selectedClip.stopDrag();
			selectedClip.removeEventListener(MouseEvent.MOUSE_UP,dropMe);
			stage.removeEventListener(MouseEvent.MOUSE_UP,dropMe);
		}
		private function showCounter(e:MouseEvent):void
		{
			MovieClip(getChildByName("CB")).hideCounterBtn.visible=true;
			MovieClip(getChildByName("CB")).showCounterBtn.visible=false;
			CounterText_mc.visible=true;
		}
		private function hideCounter(e:MouseEvent):void
		{
			MovieClip(getChildByName("CB")).hideCounterBtn.visible=false;
			MovieClip(getChildByName("CB")).showCounterBtn.visible=true;
			CounterText_mc.visible=false;
		}
		private function Break(e:MouseEvent):void
		{
			var target=e.target;
			DisableBtn(target);
			var Con=getChildByName("controls");
			DisableBtn(Con.RE);
			
			if(selectedClip!=null)
			{						
				var Num:Number=selectedClip.groupid;
				switch(Num)
				{
					case 10:
						stick10Counter+=10;
						stick100Counter-=1;
						break;
					default:
						break;
				}	
				TotalCount();
				var exxpos:Number=selectedClip.x;
				var exypos:Number=selectedClip.y;
				
				if(Num>1)
				{
					clipArray.splice(selectedClip.id,1);			
					Reassignid();
					clipcnt--;
					removeChild(selectedClip);
					selectedClip=null;
					var arr:Array=CreatePositionArray(exxpos,exypos,Num);
					for(var i:int=0;i<10;i++)
					{
						var mc:MovieClip=new MovieClip();
						var stick=getDefinitionByName("mc_"+(Num/10));
						var s=new stick();
						
						
						var sh:Shape=new Shape();
						sh.name="sh";
						sh.visible=false;
						sh.graphics.beginFill(0x99CCFF);
						sh.graphics.drawRect(-5,-5,s.width+10,s.height+10);
						sh.graphics.endFill();
						mc.addChild(sh);
						mc.addChild(s);
						addChild(mc);
						mc.buttonMode=true;
						mc.mouseChildren=false;
						mc.addEventListener(MouseEvent.MOUSE_DOWN,dragMe);
						mc.id=clipcnt;
						mc.groupid=(Num/10);
						clipArray.push([clipcnt,mc,mc.groupid]);
						mc.x=arr[i][0];
						mc.y=arr[i][1];
						clipcnt++;
					}
					
				}
			}
		}
		private function Remove(e:MouseEvent):void
		{
			var target=e.target;
			DisableBtn(target);
			var Con=getChildByName("controls");
			DisableBtn(Con.BA);
			
			if(selectedClip)
			{
				clipArray.splice(selectedClip.id,1);
				Reassignid();
				var Num:Number=selectedClip.groupid;
				switch(Num)
				{
					case 1:
						stick1Counter--;
						break;
					case 10:
						stick10Counter--;
						break;
					case 100:
						stick100Counter--;
						break;
					default:
						break;
				}	
				TotalCount();
				removeChild(selectedClip);
				selectedClip=null;
			}
		}
		private function Bundle(e:MouseEvent):void
		{			
			var target=e.target;
			
			var cnt:Number=CheckSameGroups();
			var GID:Number=selectedClip.groupid;
			//trace(selectedClip.groupid,clipArray);
			var xpos:Number=selectedClip.x;
			var ypos:Number=selectedClip.y;
			
			var arr:Array=new Array();
			for(var j:int=0;j<clipArray.length;j++)
			{
				arr[j]=clipArray[j];
			}
			var counter:Number=0;
			if(cnt>=10)
			{
				for(var i=0;i<clipArray.length;i++)
				{
					if(clipArray[i][2]==GID && counter<=10)
					{
						var cmc=clipArray[i][1];
						var removedItem:Number;
						for(var m:int=0;m<arr.length;m++)
						{
							if(arr[m][0]==clipArray[i][0])
							{
								removedItem=m;
								break;
							}
						}
						arr.splice(removedItem,1);
						removeChild(cmc);
						counter++;
						clipcnt--;
					}
					if(counter==10)
					{
						//trace(arr.length,arr)
						clipArray=arr;
						Reassignid();
						
						var mc:MovieClip=new MovieClip();
						var stick=getDefinitionByName("mc_"+(GID*10));
						var s=new stick();
						
						
						var sh:Shape=new Shape();
						sh.name="sh";
						sh.visible=false;
						sh.graphics.beginFill(0x99CCFF);
						sh.graphics.drawRect(-5,-5,s.width+10,s.height+10);
						sh.graphics.endFill();
						mc.addChild(sh);
						mc.addChild(s);
						addChild(mc);
						mc.buttonMode=true;
						mc.mouseChildren=false;
						mc.addEventListener(MouseEvent.MOUSE_DOWN,dragMe);
						mc.id=clipcnt;
						mc.groupid=(GID*10);
						clipArray.push([clipcnt,mc,mc.groupid]);
						mc.x=xpos;
						mc.y=ypos;
						clipcnt++;
						break;
					}
					
				}
			}
			
			DisableBtn(target);
			var Con=getChildByName("controls");
			DisableBtn(Con.BA);
			DisableBtn(Con.RE);
			
		}
		private function Reassignid():void
		{
			for(var i:int=0;i<clipArray.length;i++)
			{
				(clipArray[i][1]).id=i;
				clipArray[i]=[i,(clipArray[i][1]),(clipArray[i][1]).groupid];
			}
		}
		private function CreatePositionArray(xpos:Number,ypos:Number,groupNo:Number):Array
		{
			var posArray:Array=new Array();			
			if(groupNo>10)
			{
				posArray.push([xpos,ypos],[xpos+50,ypos],[xpos+100,ypos], [xpos+25,ypos+50],[xpos+75,ypos+50],[xpos,ypos+100],[xpos+50,ypos+100],[xpos+100,ypos+100],[xpos+25,ypos+150],[xpos+75,ypos+150]);
			}
			else
			{
				var startX:Number=xpos;
				for(var i:int=0;i<10;i++)
				{
					posArray.push([startX,ypos]);
					startX+=25;
				}
			}
			return posArray;
		}
		private function tint(clip:Object, newColor:Number):void
		{
			var colorTransform:ColorTransform=clip.transform.colorTransform;
			colorTransform.color=newColor;
			colorTransform.alphaMultiplier=0.5;
			clip.transform.colorTransform=colorTransform;
		}
		private function DisableBtn(btn:*)
		{
			btn.mouseEnabled=false;
			btn.alpha=0.7;
		}
		private function EnableBtn(btn:*)
		{
			btn.mouseEnabled=true;
			btn.alpha=1;
		}
		private function Reset(e:MouseEvent):void
		{
			for(var i=0;i<clipArray.length;i++)
			{
				var mclip=clipArray[i][1];
				removeChild(mclip);
			}
			CounterText_mc.visible=false;
			
			var Con=getChildByName("controls");
			DisableBtn(Con.BA);
			DisableBtn(Con.RE);
			DisableBtn(Con.BT);
			
			var CB=getChildByName("CB");
			CB.hideCounterBtn.visible=false;
			CB.showCounterBtn.visible=true;
			
			stick1Counter=0;
			stick10Counter=0;
			stick100Counter=0;
			clipcnt=0;
			clipArray=new Array();
			TotalCount();
		}
	}
}