﻿package com
{
	import flash.display.MovieClip;	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.geom.Rectangle;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.text.TextFieldAutoSize;
	import flash.geom.ColorTransform;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	import flash.text.TextFormatAlign;
	public class LadyBird extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var drop:bird=new bird();
		private var DragObj:MovieClip=new MovieClip();		
		private var DropObjArray:Array=new Array();
		private var Col1Array:Array=new Array();
		private var Col2Array:Array=new Array();
		private var AnswerTextArray:Array=new Array();
		private var sa:showanswer=new showanswer();
		private var ha:hideanswer=new hideanswer();
		private var mc:MovieClip;
		private var pageArr:Array;
		private var isDragging:Boolean;
		private var currRightPage;
		private var currLeftPage;
		private var leftNum = 1;
		private var rightNum = 1;
		
		public function LadyBird()
		{
			LoadActivityXML();
			isDragging = false;
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO_F43.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			AddLadyBird();
			AddDots();
			AddQuesText();
			AddText();
			addNumbers();
			addAnswer();
			drawFeedback();
			//AddButtons();
			//AddAnswerText();
			stage.addEventListener(MouseEvent.MOUSE_UP,onStageClicked);
			startAct();
		}
		private function onReset(eve:MouseEvent=null):void{
			/*for(var i:int=0;i< XMLObj.Dots.Dot.length();i++)
			{
				var mc = getChildByName("mc_"+Number(i))
				mc.x=XMLObj.Dots.Dot[i].@xpos;
				mc.y=XMLObj.Dots.Dot[i].@ypos;
				mc.xpos=mc.x;
				mc.ypos=mc.y;
				
			}
		    Col1Array=new Array();
			Col2Array=new Array();
			AnswerTextArray[1].htmlText=Col1Array.length;
			AnswerTextArray[2].htmlText=Col2Array.length;
			AnswerTextArray[3].htmlText=Col1Array.length+Col2Array.length;
			ha.dispatchEvent(new MouseEvent(MouseEvent.CLICK));*/
			for(var i:int=0;i< XMLObj.Dots.leftDots.Dot.length();i++)
			{
				var mc = getChildByName("leftmc_"+Number(i))
				mc.visible = false;
				
			}
			for(i=0;i< XMLObj.Dots.rightDots.Dot.length();i++)
			{
				mc = getChildByName("rightmc_"+Number(i))
				mc.visible = false;
				
			}
			var feedback:MovieClip=getChildByName("feedback") as MovieClip;
			feedback.visible = false;
			var answer:MovieClip=getChildByName("answer") as MovieClip;
			var txt:TextField = answer.getChildByName("txt") as TextField;
			txt.text = "";
		    startAct();

			
		}
		private function startAct(){
			//leftNum = Math.round(Math.random()*5)+1;
			leftNum = Math.floor(Math.random()*7);
			rightNum = Math.round(Math.random()*5)+1;
			/*while(leftNum==0 && rightNum==0){
				rightNum = Math.round(Math.random()*6);
			}*/
			var quesText = getChildByName("questxt");
			quesText.visible = true;
			quesText.text = leftNum+"";
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.questionText.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.questionText.@FontSize;
			TF.color=XMLObj.questionText.@FontColor;

			quesText.setTextFormat(TF);	
			quesText.embedFonts=true;
			var ansText = getChildByName("anstxt");
			ansText.text = leftNum+" + "+rightNum+" =";
			ansText.setTextFormat(TF);	
			ansText.embedFonts=true;
			currLeftPage = leftNum+rightNum;
			for(var i=0;i< rightNum;i++)
			{
				var myDot = getChildByName("rightmc_"+Number(i))
				myDot.visible = true;
				
			}
		}
		private function AddLadyBird():void
		{
			addChild(drop);
			drop.x=XMLObj.LadyBird.@xpos;
			drop.y=XMLObj.LadyBird.@ypos;
			DropObjArray.push(drop.left);
			DropObjArray.push(drop.right);
		}
		private function AddDots():void
		{
			for(var i:int=0;i<XMLObj.Dots.leftDots.Dot.length();i++)
			{
				mc=new dot();
				mc.index=i;
				
				mc.x=XMLObj.Dots.leftDots.Dot[i].@xpos;
				mc.y=XMLObj.Dots.leftDots.Dot[i].@ypos;
				mc.xpos=mc.x;
				mc.ypos=mc.y;
				mc.name = "leftmc_"+i
				mc.visible = false;
				addChild(mc);
				//mc.buttonMode=true;
				//mc.addEventListener(MouseEvent.MOUSE_DOWN,DragIt);
			}
			for(i=0;i<XMLObj.Dots.rightDots.Dot.length();i++)
			{
				mc=new dot();
				mc.index=i;
				
				mc.x=XMLObj.Dots.rightDots.Dot[i].@xpos;
				mc.y=XMLObj.Dots.rightDots.Dot[i].@ypos;
				mc.xpos=mc.x;
				mc.ypos=mc.y;
				mc.visible = false;
				mc.name = "rightmc_"+i;
				addChild(mc);
				//mc.buttonMode=true;
				//mc.addEventListener(MouseEvent.MOUSE_DOWN,DragIt);
			}
		}
		private function randomRange(minNum:Number, maxNum:Number):Number  
		{  
			return (Math.floor(Math.random() * (maxNum - minNum + 1)) + minNum);  
		} 
		private function AddText():void
		{
			var TxtFld:TextField=new TextField();
			TxtFld.name="anstxt";
			TxtFld.autoSize="left";
			TxtFld.selectable=false;
			TxtFld.multiline=false;
			
			
			TxtFld.htmlText=XMLObj.AnswerText;
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.AnswerText.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.AnswerText.@FontSize;
			TF.color=XMLObj.AnswerText.@FontColor;
			TF.align = "right";

			TxtFld.setTextFormat(TF);	
			TxtFld.embedFonts=true;
			
			TxtFld.x=Number(XMLObj.AnswerText.@xpos);
			TxtFld.y=Number(XMLObj.AnswerText.@ypos);
			//TxtFld.border = true;
			//AnswerTextArray.push(TxtFld);
			//TxtFld.visible=false;
			addChild(TxtFld);
		}
		private function AddQuesText(){
			var TxtFld:TextField=new TextField();
			TxtFld.name="questxt";
			TxtFld.autoSize="left";
			TxtFld.selectable=false;
			TxtFld.multiline=false;
			
			
			TxtFld.htmlText=XMLObj.questionText;
			//TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.questionText.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.questionText.@FontSize;
			TF.color=XMLObj.questionText.@FontColor;

			TxtFld.setTextFormat(TF);	
			TxtFld.embedFonts=true;
			
			TxtFld.x=Number(XMLObj.questionText.@xpos);
			TxtFld.y=Number(XMLObj.questionText.@ypos);
			//TxtFld.border = true;
			//AnswerTextArray.push(TxtFld);
			//TxtFld.visible=false;
			addChild(TxtFld);
		}
		private function AddButtons():void
		{
			
			sa.x=XMLObj.ShowAnswer.@xpos;
			sa.y=XMLObj.ShowAnswer.@ypos;
			addChild(sa);
			sa.addEventListener(MouseEvent.CLICK,showAnswer);
			
			ha.mouseEnabled=false;
			ha.alpha=.5;
			ha.x=XMLObj.HideAnswer.@xpos;
			ha.y=XMLObj.HideAnswer.@ypos;
			addChild(ha);
			ha.addEventListener(MouseEvent.CLICK,hideAnswer);
		}
		private function AddAnswerText():void
		{
			var Num:Number=XMLObj.Answers.Answer.length();
			for(var i:int=0;i<Num;i++)
			{
				var TxtFld:TextField=new TextField();
				TxtFld.name="txt_"+i;
				TxtFld.width=XMLObj.Answers.@width;
				TxtFld.height=XMLObj.Answers.@height;
				TxtFld.selectable=false;
				TxtFld.multiline=false;
				//TxtFld.border=true;				
				
				
				TxtFld.antiAliasType=AntiAliasType.ADVANCED;
				
				var TF:TextFormat=new TextFormat();
				TF.align=TextFormatAlign.CENTER;
				
				var FontC=getDefinitionByName(XMLObj.AnswerText.@noFont) as Class;
				var newFont:Font=new FontC();
				
				TF.font=newFont.fontName;	
				TF.size=XMLObj.AnswerText.@FontSize;
				TF.color=XMLObj.Answers.@FontColor;
	
				TxtFld.defaultTextFormat=TF;	
				TxtFld.htmlText="0";
				TxtFld.embedFonts=true;
				
				TxtFld.x=Number(XMLObj.Answers.Answer[i].@xpos);
				TxtFld.y=Number(XMLObj.Answers.Answer[i].@ypos);
				
				addChild(TxtFld);
				TxtFld.visible=false;
				AnswerTextArray.push(TxtFld);
			}
		}
		private function addNumbers():void {
			pageArr = [];
			var len:Number=XMLObj.numbers.children().length();			
			var numbersClip:MovieClip = getChildByName("numbersClip") as MovieClip;
			if(numbersClip!=null) removeChild(numbersClip);
			numbersClip = new MovieClip();
			numbersClip.name="numbersClip";
			
			var prevnumber:MovieClip;
			for (var i:Number=0; i<XMLObj.numbers.number.length(); i++) {
				pageArr[i] = ({no:XMLObj.numbers.number[i].@no,word:XMLObj.numbers.number[i].@word});				
				//var str:String = (numBtn.currentFrame==3) ? pageArr[i].no : pageArr[i].word;
				var str:String = pageArr[i].no;
				var number:MovieClip = new MovieClip();
				number.name="number_"+i;
				var txt:TextField = addTxt(str);
				txt.name = "txt";
				var font:String = XMLObj.numbers.@no_font;
				var fontSize:Number = Number(XMLObj.numbers.@no_fontSize);
				var fontColor:uint = uint(XMLObj.numbers.@no_fontColor);
				var gap:Number = Number(XMLObj.numbers.@no_gap);
				//trace("fontSize = "+fontSize);
				var fnt=getDefinitionByName(font) as Class;
				var fon:Font=new fnt();
				
				changeFormat(txt,fon.fontName,fontSize,fontColor);
				number.addChild(txt);
				prevnumber = numbersClip.getChildByName("number_"+(i-1)) as MovieClip;				
				number.x =(prevnumber==null) ?  0 : (prevnumber.x + prevnumber.width + gap);
				number.y = 0;
				
				number.buttonMode=true;
				number.mouseChildren = false;
				number.addEventListener(MouseEvent.MOUSE_DOWN,numberClicked);
				numbersClip.addChild(number);
				trace("pageArr = "+pageArr[i].no);
			}
			numbersClip.x = (XMLObj.numbers.@no_x.length>0) ? Number(XMLObj.numbers.@no_x) : boundary.x + (boundary.width - numbersClip.width)/2;
			numbersClip.y = Number(XMLObj.numbers.@no_y);
			/*if(numBtn.currentFrame==3){
				numbersClip.x = (XMLObj.numbers.@no_x.length>0) ? Number(XMLObj.numbers.@no_x) : boundary.x + (boundary.width - numbersClip.width)/2;
				numbersClip.y = Number(XMLObj.numbers.@no_y);
			}else{
				numbersClip.x = (XMLObj.numbers.@word_x.length>0) ? Number(XMLObj.numbers.@word_x) : boundary.x + (boundary.width - numbersClip.width)/2;
				numbersClip.y = Number(XMLObj.numbers.@word_y);
			}*/
			addChild(numbersClip);
		}
		private function numberClicked(e:MouseEvent):void {
			if (!isDragging) {
				currRightPage=Number(pageArr[Number(e.target.name.split("_")[1])].no);
				trace("currRightPage = "+currRightPage);
				var dupSmallPage:MovieClip=duplicateSmallPage(e.target as MovieClip);
				dupSmallPage.name="dupSmallPage";
				dupSmallPage.x = mouseX - dupSmallPage.width/2;
				dupSmallPage.y = mouseY - dupSmallPage.height/2;
				addChild(dupSmallPage);
				var boundary:Rectangle=new Rectangle(0,0,710,450);
				dupSmallPage.startDrag(false,boundary);
			}
		}
		private function duplicateSmallPage(clone:MovieClip):MovieClip {
			var bmd:BitmapData=new BitmapData(clone.width, (clone.height),true,0x00000000);
			bmd.draw(clone);

			var holder:Bitmap = new Bitmap();
			holder.bitmapData=bmd;
			holder.smoothing=true;
			var obj:MovieClip = new MovieClip();
			obj.addChild(holder);
			return obj;
		}
		private function onStageClicked(e:MouseEvent):void {
			try
			{
				var cnt:Number=0;
				var ansClip:MovieClip = getChildByName("answer") as MovieClip;
				var dupSmallPage:MovieClip = getChildByName("dupSmallPage") as MovieClip;
				trace("ganesh "+mouseX+" -- "+mouseY);
				if((mouseX >=ansClip.x && mouseX <=ansClip.x+ansClip.width) && (mouseY >=ansClip.y && mouseY <=ansClip.y+ansClip.height)){
					trace("EMNTER");
					cnt++;
					loadAnswerPage();
				}
				
				var numbersClip:MovieClip = getChildByName("numbersClip") as MovieClip;
				for (var j:Number=0; j<pageArr.length; j++) {
					var number:MovieClip = numbersClip.getChildByName("number_"+j) as MovieClip;
					if((numbersClip.mouseX >=number.x && numbersClip.mouseX <=number.x+number.width) && (numbersClip.mouseY >=number.y && numbersClip.mouseY <=number.y+number.height)){					
						if(dupSmallPage!=null) removeChild(dupSmallPage);
						isDragging = false;					
						number.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));					
						break;
					}
				}
				if(cnt==0)
				{
					removeChild(dupSmallPage);
				}
			}catch(e:Error)
			{
			}
		}
		private function loadAnswerPage():void {
			//trace("REACJ "+Number(pageArr[currRightPage].no));
			var dupSmallPage:MovieClip=getChildByName("dupSmallPage") as MovieClip;
			dupSmallPage.stopDrag();
			removeChild(dupSmallPage);
			var answer:MovieClip=getChildByName("answer") as MovieClip;
			var txt:TextField = answer.getChildByName("txt") as TextField;
			txt.text = String(Number(pageArr[currRightPage-1].no));
			trace(" GGGG = "+txt.text);
			var font:String = XMLObj.numbers.@no_font;
			var fontSize:Number = Number(XMLObj.numbers.@no_fontSize);
			var fontColor:uint = uint(XMLObj.numbers.@no_fontColor);
			
			var fnt=getDefinitionByName(font) as Class;
			var fon:Font=new fnt();
			
			changeFormat(txt,fon.fontName,fontSize,fontColor);
			txt.x = (answer.width - txt.width)/2;
			txt.y = (answer.height - txt.height)/2;
			trace(currLeftPage,currRightPage)
			if (currLeftPage==currRightPage) {
				showFeedback(true);
			} else {
				showFeedback(false);
			}
		}
		private function showFeedback(isCorrect:Boolean):void {
			var feedback:MovieClip=getChildByName("feedback") as MovieClip;
			if (isCorrect) {
				feedback.gotoAndStop(2);
				var quesText = getChildByName("questxt");
				quesText.visible = false;
				for(var i=0;i< leftNum;i++)
				{
					var myDot = getChildByName("leftmc_"+Number(i))
					myDot.visible = true;
				}
			} else {
				feedback.gotoAndStop(1);
				quesText = getChildByName("questxt");
				quesText.visible = true;
				for(i=0;i< leftNum;i++)
				{
					myDot = getChildByName("leftmc_"+Number(i))
					myDot.visible = false;
				}
			}
			feedback.visible=true;
		}
		private function drawFeedback():void {
			var feedback:Feedback = new Feedback();
			feedback.name="feedback";
			feedback.x=Number(XMLObj.feedback.@x);
			feedback.y=Number(XMLObj.feedback.@y);
			feedback.visible=false;
			addChild(feedback);
		}
		private function addTxt(txtStr:String):TextField{
			var txt:TextField = new TextField();
			txt.selectable = false;
			txt.background = false;
			txt.border = false;
			txt.autoSize = TextFieldAutoSize.LEFT;
			txt.text = txtStr;			
			txt.embedFonts=true;
			return txt;
		}
		private function changeFormat(targetTxt:TextField,font:String,fontSize:Number,fontColor:uint):void{
			var txt:TextField = targetTxt;
			var txtFormat:TextFormat = new TextFormat();
			txtFormat.leftMargin = 0;
			txtFormat.rightMargin = 0;
			txtFormat.font = font;
			txtFormat.bold = true;			
			txtFormat.size = fontSize;
			txtFormat.color = fontColor;
			
			txt.setTextFormat(txtFormat);
		}
		private function addAnswer():void {
			var answer:MovieClip = getChildByName("answer") as MovieClip;
			if(answer!=null) removeChild(answer);
			answer = drawPage(Number(XMLObj.answer.@width),Number(XMLObj.answer.@height),Number(XMLObj.answer.@bgColor),((XMLObj.answer.@bgColor=="")?0:1), Number(XMLObj.answer.@borderSize), Number(XMLObj.answer.@borderColor));
			answer.name="answer";
			var txt:TextField = addTxt(" ");
			txt.name = "txt";
			answer.addChild(txt);
			answer.x=Number(XMLObj.answer.@x);
			answer.y=Number(XMLObj.answer.@y);
			addChild(answer);
		}
		private function resizePage(page:MovieClip, w:Number, h:Number):void {
			page.bg.x=0;
			page.bg.y=0;
			page.bg.width=w;
			page.bg.height=h;			
			//if (page.border.visible) {
				page.border.right.height=h;
				page.border.top.width=w;
				page.border.left.height=h;
				page.border.bottom.width=w;

				page.border.left.x=0;
				page.border.left.y=0;
				page.border.top.x=0;
				page.border.top.y=0;

				page.border.right.x=page.border.top.x+page.border.top.width-page.border.right.width;
				page.border.right.y=0;
				page.border.bottom.x=0;
				page.border.bottom.y=page.border.left.y+page.border.left.height-page.border.bottom.height;
			//}
		}
		private function drawPage(w:Number, h:Number, fillColor:Number, fillAlpha:Number, borderSize:Number, borderColor:Number):MovieClip {
			var page:Page = new Page();
			var pageColorTrans:ColorTransform = new ColorTransform();
			pageColorTrans.color=fillColor;
			page.bg.transform.colorTransform=pageColorTrans;
			page.bg.alpha=fillAlpha;
			page.border.visible = (borderSize>0) ? true : false;
			if (page.border.visible) {
				var borderColorTrans:ColorTransform = new ColorTransform();
				borderColorTrans.color=borderColor;
				page.border.transform.colorTransform=borderColorTrans;

				page.border.left.width=borderSize;
				page.border.right.width=borderSize;
				page.border.top.height=borderSize;
				page.border.bottom.height=borderSize;
			}
			resizePage(page,w,h);
			return page;
		}
		private function DragIt(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			DragObj=tar;
			setChildIndex(DragObj,numChildren-1);
			DragObj.startDrag(false,new Rectangle(0,0,760-DragObj.width,530-DragObj.height));
			DragObj.addEventListener(MouseEvent.MOUSE_UP,DropIt);
			stage.addEventListener(MouseEvent.MOUSE_UP,DropIt);
			
			for(var i:int=0;i<Col1Array.length;i++)
			{
				if(Col1Array[i].index==DragObj.index)
				{
					Col1Array.splice(i,1);
					break;
				}
			}
			for(i=0;i<Col2Array.length;i++)
			{
				if(Col2Array[i].index==DragObj.index)
				{
					Col2Array.splice(i,1);
					break;
				}
			}			
		}
		private function DropIt(e:MouseEvent):void
		{
			if(DragObj)
			{				
				DragObj.stopDrag();
				DragObj.removeEventListener(MouseEvent.MOUSE_UP,DropIt);
				stage.removeEventListener(MouseEvent.MOUSE_UP,DropIt);
				var cnt:Number=0;
				for(var i:int=0;i<DropObjArray.length;i++)
				{
					if(DragObj.hitTestObject(DropObjArray[i]))
					{
						cnt++;
						if(i==0)
						{
							Col1Array.push(DragObj);
						}else
						{
							Col2Array.push(DragObj);
						}
						 break;
					}
				}
				if(cnt==0)
				{
					DragObj.x=DragObj.xpos;
					DragObj.y=DragObj.ypos;
				}
				DragObj=new MovieClip();
			}
			AnswerTextArray[1].htmlText=Col1Array.length;
			AnswerTextArray[2].htmlText=Col2Array.length;
			AnswerTextArray[3].htmlText=Col1Array.length+Col2Array.length;
			//trace("gan = "+AnswerTextArray[3].htmlText);
		}
		private function showAnswer(e:MouseEvent):void
		{
			sa.mouseEnabled=false;
			ha.mouseEnabled=true;
			sa.alpha=.5;
			ha.alpha=1;
			for(var i:int=0;i<AnswerTextArray.length;i++)
			{
				AnswerTextArray[i].visible=true;
			}
		}
		private function hideAnswer(e:MouseEvent):void
		{
			sa.mouseEnabled=true;
			ha.mouseEnabled=false;
			sa.alpha=1;
			ha.alpha=.5;
			for(var i:int=0;i<AnswerTextArray.length;i++)
			{
				AnswerTextArray[i].visible=false;
			}
		}
	}
}