﻿package com{
	
	import flash.display.MovieClip;	
	import flash.utils.getDefinitionByName;
	import flash.geom.Rectangle;
	import flash.events.MouseEvent;	
	
	public class sortCoins extends MovieClip{
		private var coinsMC:MovieClip = new MovieClip();
		private var draggedCoin:MovieClip;
		
		private var coins:String = "fiveC_H_mc,fiveC_T_mc,tenC_H_mc,tenC_T_mc,twentyC_H_mc,twentyC_T_mc,fiftyC_H_mc,fiftyC_T_mc,oneD_H_mc,oneD_T_mc,twoD_H_mc,twoD_T_mc";
		private var coinsArr:Array = [];
		private var shuffledCoinsArr:Array = [];
		private var coinsPosArr:Array = [];
		private var dropTarArr:Array = ["fiveC_drop_mc", "tenC_drop_mc", "twentyC_drop_mc", "fiftyC_drop_mc", "oneD_drop_mc", "twoD_drop_mc"];
		private var dropPosArr:Array = [];
		private var stageWidth:Number = 760;
		private var coinsXPos:Number = 0;
		private var coinsYPos:Number = 458;
		private var coinCnt:Number = 1;
		private var droppedCoinCnt:Number = 0;
		
		public function sortCoins():void{
			addChild(coinsMC);
			fnArrayShuffle();
			fnDisplayCoins();
			reset_btn.addEventListener(MouseEvent.CLICK, reset);
			reset_btn.mouseChildren = false;
			reset_btn.buttonMode = true;
			for(var i:Number = 0; i < dropTarArr.length; i++){
				var dropTarClip:MovieClip = getChildByName(dropTarArr[i]) as MovieClip;
				dropTarClip.cnt = 1;
				dropPosArr.push(dropTarClip.x + "_" + dropTarClip.y);
				
			}
			
		}
		
		//shuffles coin array for displaying coins in random position
		private function fnArrayShuffle():void{
			coinsArr = [];
			coinsArr = coins.split(",");
			shuffledCoinsArr = []; 
			while(coinsArr.length > 0) {
				shuffledCoinsArr.push(coinsArr.splice(Math.round(Math.random() * (coinsArr.length - 1)), 1)[0]);
			}
		}
		
		//displays coins on stage
		private function fnDisplayCoins():void{
			var clipClass:Class;
			var clipMC:MovieClip;
			for(var i:Number = 0; i < shuffledCoinsArr.length; i++){
				clipClass = getDefinitionByName(shuffledCoinsArr[i]) as Class;
				clipMC = new clipClass();
				coinsMC.addChild(clipMC);
				clipMC.name = shuffledCoinsArr[i];
				clipMC.x = (105 * coinCnt);
				clipMC.y = coinsYPos;
				coinsPosArr.push(clipMC.x+"_"+clipMC.y);
				coinCnt++;
				if(coinCnt == 7){
					coinCnt = 1;
					coinsYPos = 348;
				}
				//adding events for coin
				clipMC.buttonMode = true;
				clipMC.addEventListener(MouseEvent.MOUSE_DOWN, fnMouseDownCoin);
				clipMC.mouseChildren = false;
			}
		}
		private function fnMouseDownCoin(eve:MouseEvent):void{
			var clipMC:MovieClip = eve.target as MovieClip;
			clipMC.addEventListener(MouseEvent.MOUSE_MOVE, fnStartDragCoin);
			clipMC.addEventListener(MouseEvent.MOUSE_UP, fnStopDragCoin);
		}
		private function fnStartDragCoin(eve:MouseEvent):void{
			draggedCoin = eve.currentTarget as MovieClip;
			 eve.target.parent.setChildIndex(draggedCoin, (draggedCoin.parent.numChildren-1));
			 eve.target.startDrag(true, new Rectangle(10, 10, 690, 460));// drag area restriction										
		}
		
		//When coin dragged, mouseX and mouseY is checked whether it is with the drop target range. If it is within drop area target range, coin is placed on the respective drop area. Coin is dropped on drop target area only when dragged coin value and drop target area money value are same. If drop target money value and dragged coin value are not same it is returned to the original position. When another coin from original pool of coins while dragging, clicked coin will be attached to the mouse cursor and dragged coin will reset to its original position and events are removed. 
		private function fnStopDragCoin(eve:MouseEvent):void{
			var dragClip:MovieClip = eve.currentTarget as MovieClip;
			if(dragClip.dropTarget !== null && String(dragClip.dropTarget) != "[object Bitmap]"){//returns null when dropped on stage
				var dropTar:String = dragClip.dropTarget.parent.name;
				var dropClip:MovieClip;
				for(var i:Number = 0; i < dropPosArr.length; i++){					
					var dropTarEndX:Number = Number(dropPosArr[i].split("_")[0]) + fiveC_drop_mc.width;
					var dropTarEndY:Number = Number(dropPosArr[i].split("_")[1]) + fiveC_drop_mc.height
					//checks for drop area target - used instead of hitTestObject
					if(mouseX >=  Number(dropPosArr[i].split("_")[0]) && mouseX <=  dropTarEndX && mouseY >=  Number(dropPosArr[i].split("_")[1]) && mouseY <=  dropTarEndY){
						if(dragClip.name.split("_")[0] == dropTarArr[i].split("_")[0]){//checks for drag and drop money value
							dropClip = getChildByName(dropTarArr[i]) as MovieClip;
							dragClip.x = dropClip.x + dropClip.width/2;
							var dropYHei:Number = (dropClip.y + dropClip.height)/(3 - dropClip.cnt);
							dragClip.y = dropYHei - 35 - (30 * (dropClip.cnt -1));
							dragClip.mouseEnabled = false;
							dropClip.cnt++;
							dragClip.stopDrag();
							dragClip.buttonMode = false;
							dragClip.removeEventListener(MouseEvent.MOUSE_DOWN, fnMouseDownCoin);
							dragClip.removeEventListener(MouseEvent.MOUSE_MOVE, fnStartDragCoin);
							dragClip.removeEventListener(MouseEvent.MOUSE_UP, fnStopDragCoin);
							droppedCoinCnt++;
							if(droppedCoinCnt == shuffledCoinsArr.length){
								var greatMC:great_mc = new great_mc();
								addChild(greatMC);
								greatMC.name = "greatMC";
								greatMC.x = stageWidth/2;
								greatMC.y = 400;
							}
							break;
						}else{							
							//fnReturnDrag2OrgPos(dragClip);//returned to original position if the drop and drag monety value not matched
							var clipName:String = dragClip.name;
							coinsMC.removeChild(dragClip);
							var newDragClass:Class = getDefinitionByName(clipName) as Class;
							var newDragClip:MovieClip = new newDragClass();
							coinsMC.addChild(newDragClip);
							newDragClip.name = clipName;
							newDragClip.buttonMode = true;
							newDragClip.addEventListener(MouseEvent.MOUSE_DOWN, fnMouseDownCoin);
							fnReturnDrag2OrgPos(newDragClip);
						}
					}					
				}
				if(dropTar.indexOf("drop") == -1 && mouseY >= 295){//if dropped on coin in original coins pool, clicked coin is attached to cursor and previous coin is reset 				
					dropClip = dragClip.dropTarget.parent as MovieClip
					if(dropClip.enabled){//doesn't attach new coin if the clicked coin has already been disabled
						fnReturnDrag2OrgPos(dragClip);
						dragClip.enabled = false;
						dragClip.buttonMode = false;
						dragClip.removeEventListener(MouseEvent.MOUSE_DOWN, fnMouseDownCoin);
						dragClip.removeEventListener(MouseEvent.MOUSE_MOVE, fnStartDragCoin);
						dragClip.removeEventListener(MouseEvent.MOUSE_UP, fnStopDragCoin);
						var dropTargClip:MovieClip = coinsMC.getChildByName(dropTar) as MovieClip;//attaches clicked coin
						dropTargClip.dispatchEvent(new MouseEvent(MouseEvent.MOUSE_DOWN));//dispatches event of clicked
					}
					
				}
			}
		}
		
		//returns the coin to its original position
		private function fnReturnDrag2OrgPos(clip:MovieClip):void{
			for(var ii:Number = 0; ii < shuffledCoinsArr.length; ii++){
				var orgCoinClip:MovieClip = coinsMC.getChildByName(shuffledCoinsArr[ii]) as MovieClip;
				if(clip.name == orgCoinClip.name){
					clip.stopDrag();
					clip.x = Number(coinsPosArr[ii].split("_")[0]);
					clip.y = Number(coinsPosArr[ii].split("_")[1]);	
					break;
				}
			}
		}
		
		//removes children of reference clip
		private function removeChildOf(clip:*):void{
			for(var i:Number = clip.numChildren-1; i >= 0; i--){
				clip.removeChild(clip.getChildAt(i));
			}
		}
		
		private function reset(eve:MouseEvent):void{
			removeChildOf(coinsMC);
			coinsYPos = 458;
			coinCnt = 1;
			coinsPosArr = [];
			for(var i:Number = 0; i < dropTarArr.length; i++){
				var dropTarClip:MovieClip = getChildByName(dropTarArr[i]) as MovieClip;
				dropTarClip.cnt = 1;
			}
			droppedCoinCnt = 0;
			if(getChildByName("greatMC") != null){
				removeChild(getChildByName("greatMC"));
			}
			fnArrayShuffle();
			fnDisplayCoins();			
		}
	}
}