﻿package com
{
	import flash.display.MovieClip;
	import flash.events.*; 
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	//import fl.text.TLFTextField;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.geom.ColorTransform;
	
	import flash.text.Font;
	import flash.utils.getDefinitionByName;
	
	public class RandomNumber{
		private var targetClip:MovieClip;
		private var xmlData:XML;
		private var clickedIndex:Number;
		private var currIndex:Number;
		private var startNum:Number;
		private var endNum:Number;
		private var squareArr:Array;
		private var type:String;
		
		public function RandomNumber(target:MovieClip):void{
			targetClip = target;
			targetClip.visible = false;
			xmlData = new XML();
			currIndex = -1;
			squareArr = new Array();
		}
		public function setUp(url:String):void{
			enableBtns(false);
			loadXML(url);
		}
		private function randomRange(max:Number, min:Number = 0):Number
		{
			if(max == min) return max;
			var currRnd:Number = Math.round(Math.random() * (max - min) + min);
			var prevRnd:Number = currIndex;
			if(prevRnd == currRnd){
				currRnd = randomRange(max,min);
			}
			return currRnd;
		}
		private function rndArr(arr:Array):Array{
			var newArr:Array = []; 
			while (arr.length > 0) {
				newArr.push(arr.splice(Math.round(Math.random() * (arr.length - 1)), 1)[0]);
			}			
			return newArr;
		}		
		private function enableBtns(val:Boolean):void{
			targetClip.shuffleBtn.enabled = val;		
			targetClip.reset_btn.mouseChildren = val;
			/*targetClip.btn_10.enabled = val;
			targetClip.btn_20.enabled = val;
			targetClip.btn_30.enabled = val;
			
			targetClip.btn_10.buttonMode = true;
			targetClip.btn_20.buttonMode = true;
			targetClip.btn_30.buttonMode = true;
			targetClip.btn_10.mouseChildren = false;
			targetClip.btn_20.mouseChildren = false;
			targetClip.btn_30.mouseChildren = false;
			targetClip.btn_10.addEventListener(MouseEvent.MOUSE_OVER,onmouseover)
			targetClip.btn_10.addEventListener(MouseEvent.MOUSE_OUT,onmouseout)
			targetClip.btn_10.addEventListener(MouseEvent.CLICK,function(){
				startNum = 0;
				endNum = 10;
				targetClip.btn_10.removeEventListener(MouseEvent.MOUSE_OVER,onmouseover)
				targetClip.btn_10.removeEventListener(MouseEvent.MOUSE_OUT,onmouseout)
				targetClip.btn_20.addEventListener(MouseEvent.MOUSE_OVER,onmouseover)
				targetClip.btn_20.addEventListener(MouseEvent.MOUSE_OUT,onmouseout)
				targetClip.btn_30.addEventListener(MouseEvent.MOUSE_OVER,onmouseover)
				targetClip.btn_30.addEventListener(MouseEvent.MOUSE_OUT,onmouseout)
				targetClip.btn_10.gotoAndStop(3);
				targetClip.btn_20.gotoAndStop(1);
				targetClip.btn_30.gotoAndStop(1);
				reset();
			});
			targetClip.btn_20.addEventListener(MouseEvent.MOUSE_OVER,onmouseover)
			targetClip.btn_20.addEventListener(MouseEvent.MOUSE_OUT,onmouseout)
			targetClip.btn_20.addEventListener(MouseEvent.CLICK,function(){
				startNum = 0;
				endNum = 20;
				targetClip.btn_20.removeEventListener(MouseEvent.MOUSE_OVER,onmouseover)
				targetClip.btn_20.removeEventListener(MouseEvent.MOUSE_OUT,onmouseout)
				targetClip.btn_10.addEventListener(MouseEvent.MOUSE_OVER,onmouseover)
				targetClip.btn_10.addEventListener(MouseEvent.MOUSE_OUT,onmouseout)
				targetClip.btn_30.addEventListener(MouseEvent.MOUSE_OVER,onmouseover)
				targetClip.btn_30.addEventListener(MouseEvent.MOUSE_OUT,onmouseout)
				targetClip.btn_10.gotoAndStop(1);
				targetClip.btn_20.gotoAndStop(3);
				targetClip.btn_30.gotoAndStop(1);
				reset();
			});
			targetClip.btn_30.addEventListener(MouseEvent.MOUSE_OVER,onmouseover)
			targetClip.btn_30.addEventListener(MouseEvent.MOUSE_OUT,onmouseout)
			targetClip.btn_30.addEventListener(MouseEvent.CLICK,function(){
				startNum = 0;
				endNum = 30;
				targetClip.btn_30.removeEventListener(MouseEvent.MOUSE_OVER,onmouseover)
				targetClip.btn_30.removeEventListener(MouseEvent.MOUSE_OUT,onmouseout)
				targetClip.btn_20.addEventListener(MouseEvent.MOUSE_OVER,onmouseover)
				targetClip.btn_20.addEventListener(MouseEvent.MOUSE_OUT,onmouseout)
				targetClip.btn_10.addEventListener(MouseEvent.MOUSE_OVER,onmouseover)
				targetClip.btn_10.addEventListener(MouseEvent.MOUSE_OUT,onmouseout)
				targetClip.btn_10.gotoAndStop(1);
				targetClip.btn_20.gotoAndStop(1);
				targetClip.btn_30.gotoAndStop(3);
				reset();
			});*/
			targetClip.shuffleBtn.buttonMode = true;
			targetClip.shuffleBtn.mouseChildren = false;
			targetClip.shuffleBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseover)
			targetClip.shuffleBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout)
			targetClip.shuffleBtn.mouseChildren = false;
			targetClip.shuffleBtn.addEventListener(MouseEvent.MOUSE_DOWN,function(e:MouseEvent){
				e.target.gotoAndStop(3);
			});
			targetClip.shuffleBtn.addEventListener(MouseEvent.CLICK,function(e:MouseEvent){
				e.target.gotoAndStop(1);
				reDraw();
			});
			targetClip.reset_btn.addEventListener(MouseEvent.CLICK,function(){
				reset();
			});
		}
		private function onmouseover(eve:MouseEvent=null):void{
			var btn= eve.target;
			btn.gotoAndStop(2);
		}
		private function onmouseout(eve:MouseEvent=null):void{
			var btn= eve.target;
			btn.gotoAndStop(1);
		}
		
		private function loadXML(path:String){			
			var urlRequest:URLRequest = new URLRequest(path);
			var urlLoader:URLLoader = new URLLoader(urlRequest);
			urlLoader.addEventListener(Event.COMPLETE, xmlLoaded);
		}
		private function xmlLoaded(e:Event):void{
			xmlData = new XML(e.target.data);
			type = xmlData.@type.toString().toLowerCase();			
			enableBtns(true);
			//targetClip.btn_20.dispatchEvent(new MouseEvent(MouseEvent.CLICK));
			startNum = 10;
			endNum = 99;
			reset();
			targetClip.visible = true;
		}		
		
		private function changeColor(target:MovieClip,color:uint):void{
			var cColor:ColorTransform = new ColorTransform();
			cColor.color = color;
			if (target != null )
			{
			target.bg.transform.colorTransform = cColor;			
			}
		}
		private function getIndex(num:Number):Number{
			var index:Number;
			for(var i=0;i<squareArr.length;i++){
				if(Number(squareArr[i]) == num){
					index = i;
					break;
				}
			}
			return index;
		}
		private function reset():void{
			if(targetClip.getChildByName("squareClip")!=null) targetClip.removeChild(targetClip.getChildByName("squareClip"));
			if(targetClip.getChildByName("feedback")!=null) targetClip.removeChild(targetClip.getChildByName("feedback"));
			if(targetClip.getChildByName("answer")!=null) targetClip.removeChild(targetClip.getChildByName("answer"));
			clickedIndex = -1;			
			var row:Number = Number(xmlData.range.@row);
			var col:Number = Number(xmlData.range.@col);
			squareArr = [];
			if(endNum > (row*col)){
				//row++;
				//col++;
			}
			for(var i=0;i<(row * col);i++){
				if(i<=(endNum-startNum)){
					//squareArr.push(startNum+i);
					squareArr.push(randomRange(startNum,endNum));
				}else{
					squareArr.push(randomRange(startNum,endNum));
				}
			}
			squareArr = rndArr(squareArr);
			
			drawSquares();
			
			if(type == "nextbest"){
				drawAnswer();
				drawFeedback();
			}
			reDraw();
		}
		public function reDraw():void{			
			var squareClip:MovieClip = targetClip.getChildByName("squareClip") as MovieClip;
			if(currIndex != -1){				
				var prevSquare:MovieClip = squareClip.getChildByName("square_"+currIndex) as MovieClip;
				changeColor(prevSquare,uint(xmlData.squareSet.square[passVal].@bgColor));				
			}
			if(type == "nextbest"){
				var feedback:MovieClip = targetClip.getChildByName("feedback") as MovieClip;
				feedback.visible = false;
				currIndex = getIndex(randomRange(startNum,endNum-1));
			}else{
				currIndex = randomRange(0,squareArr.length-1);
			}
			var currSquare:MovieClip = squareClip.getChildByName("square_"+currIndex) as MovieClip;
			changeColor(currSquare,uint(xmlData.range.@selectedColor));
			if(clickedIndex != -1){
				var clickedSquare:MovieClip = squareClip.getChildByName("square_"+clickedIndex) as MovieClip;
				changeColor(clickedSquare,uint(xmlData.squareSet.square[passVal].@bgColor));
			}
		}
		private function drawPage(w:Number, h:Number, fillColor:Number, fillAlpha:Number, borderSize:Number, borderColor:Number):MovieClip{
			var page:Page = new Page();
			var pageColorTrans:ColorTransform = new ColorTransform();
   			pageColorTrans.color = fillColor;
		    page.bg.transform.colorTransform = pageColorTrans;
			page.bg.alpha = fillAlpha;
			page.border.visible = (borderSize>0) ? true : false;
			if(page.border.visible){
				var borderColorTrans:ColorTransform = new ColorTransform();
				borderColorTrans.color = borderColor;
				page.border.transform.colorTransform = borderColorTrans;
				
				page.border.left.width = borderSize;				
				page.border.right.width = borderSize;
				page.border.top.height = borderSize;
				page.border.bottom.height = borderSize;
			}
			resizePage(page,w,h);
			return page;
		}
		private function resizePage(page:MovieClip, w:Number, h:Number):void{
			page.bg.x = 0;
			page.bg.y = 0;
			page.bg.width = w;
			page.bg.height = h;
				
			//if(page.border.visible){				
				page.border.right.height = h;
				page.border.top.width = w;
				page.border.left.height = h;				
				page.border.bottom.width = w;
				
				page.border.left.x = 0;
				page.border.left.y = 0;
				page.border.top.x = 0;
				page.border.top.y = 0;
				
				page.border.right.x = page.border.top.x + page.border.top.width - page.border.right.width;
				page.border.right.y = 0;			
				page.border.bottom.x = 0;
				page.border.bottom.y = page.border.left.y + page.border.left.height - page.border.bottom.height;
			//}			
		}
		private function addTxt(target:MovieClip,str:String):void{
			var txt:TextField = new TextField();
			txt.name = "txt";
			txt.selectable = false;
			txt.background = false;
			txt.border = false;
			txt.autoSize = TextFieldAutoSize.CENTER;
			txt.text = str;			
			changeTxtFormat(txt);			
			txt.x = (target.width - txt.width)/2;
			txt.y = (target.height - txt.height)/2;			
			target.addChild(txt);
			txt.embedFonts=true;
		}
		var passVal:Number
		private function changeTxtFormat(txt:TextField):void{
			var txtFormat:TextFormat = new TextFormat();
			//txtFormat.bold = true;
			
			var fnt=getDefinitionByName(xmlData.range.@font) as Class;
			var fon:Font=new fnt();
			txtFormat.font = fon.fontName;
			txtFormat.size = Number(xmlData.range.@fontSize);
			txtFormat.color = uint(xmlData.range.@fontColor);
			txt.setTextFormat(txtFormat);
		}
		private function drawSquares():void{
			var squareClip:MovieClip = new MovieClip();
			squareClip.name = "squareClip";
			var row:Number = Number(xmlData.range.@row);
			var col:Number = Number(xmlData.range.@col);
			if(endNum > (row*col)){
				//row++;
				//col++;
			}
			
			if (endNum == 10)
			{
				passVal = 0
			}
			else if (endNum == 20)
			{
				passVal = 1
			}
			else
			{
				passVal = 2
			}
			
			
			for(var i=0;i<(row*col);i++){
				var square:MovieClip = drawPage(Number(xmlData.squareSet.square[passVal].@width), Number(xmlData.squareSet.square[passVal].@height),  Number(xmlData.squareSet.square[passVal].@bgColor), ((xmlData.squareSet.square[passVal].@bgColor=="")?0:1), Number(xmlData.squareSet.square[passVal].@borderSize), Number(xmlData.squareSet.square[passVal].@borderColor));
				square.name = "square_"+i;
				addTxt(square,squareArr[i].toString());
				square.x = ((i%row) * Number(xmlData.squareSet.square[passVal].@width));
				square.y = (Math.floor(i/col) * Number(xmlData.squareSet.square[passVal].@height));
				if((i%row)>0){
					square.border.left.visible = false;					
				}
				if(Math.floor(i/col)>0){
					square.border.top.visible = false;
				}
				squareClip.addChild(square);
				if(type == "nextbest"){
					square.mouseChildren = false;
					square.addEventListener(MouseEvent.CLICK,squareClicked);
				}
			}
			squareClip.x = (xmlData.squareSet.square[passVal].@x.length>0) ? Number(xmlData.squareSet.square[passVal].@x) : (targetClip.boundary.width - squareClip.width)/2;
			squareClip.y = Number(xmlData.squareSet.square[passVal].@y);
			targetClip.addChild(squareClip);
		}
		private function drawAnswer():void{
			var answer:MovieClip = drawPage(Number(xmlData.square.@width), Number(xmlData.square.@height),  Number(xmlData.square.@bgColor), ((xmlData.square.@bgColor=="")?0:1), Number(xmlData.square.@borderSize), Number(xmlData.square.@borderColor));
			answer.name = "answer";
			addTxt(answer," ");
			var txt:TextField = answer.getChildByName("txt") as TextField;
			txt.x = (answer.width - txt.width)/2;
			txt.y = (answer.height - txt.height)/2;
			answer.x = Number(xmlData.answer.@x);
			answer.y = Number(xmlData.answer.@y);
			targetClip.addChild(answer);
		}
		private function drawFeedback():void{
			var feedback:Feedback = new Feedback();
			feedback.name = "feedback";	
			feedback.x = Number(xmlData.feedback.@x);
			feedback.y = Number(xmlData.feedback.@y);
			feedback.visible = false;
			targetClip.addChild(feedback);
		}
		private function squareClicked(e:MouseEvent):void{
			var id:Number = Number(e.target.name.split("_")[1]);
			if(currIndex == id) return;
			var squareClip:MovieClip = targetClip.getChildByName("squareClip") as MovieClip;
			if(clickedIndex != -1){
				var prevSquare:MovieClip = squareClip.getChildByName("square_"+clickedIndex) as MovieClip;
				changeColor(prevSquare,uint(xmlData.square.@bgColor));
			}
			clickedIndex = id;
			var isCorrect:Boolean = Number(squareArr[id]) == Number(squareArr[currIndex])+1;
			showAnswer(isCorrect);
			showFeedback(isCorrect);		
		}		
		private function showAnswer(isCorrect:Boolean):void{
			var squareClip:MovieClip = targetClip.getChildByName("squareClip") as MovieClip;
			var currSquare:MovieClip = squareClip.getChildByName("square_"+clickedIndex) as MovieClip;			
			var answer:MovieClip = targetClip.getChildByName("answer") as MovieClip;
			if(isCorrect){
				changeColor(currSquare,uint(xmlData.range.@correctColor));
				changeColor(answer,uint(xmlData.range.@correctColor));
			}else{
				changeColor(currSquare,uint(xmlData.square.@bgColor));
				changeColor(answer,uint(xmlData.square.@bgColor));
			}
			var txt:TextField = answer.getChildByName("txt") as TextField;
			txt.text = squareArr[clickedIndex].toString();
			changeTxtFormat(txt);
			txt.x = (answer.width - txt.width)/2;
			txt.y = (answer.height - txt.height)/2;
		}
		private function showFeedback(isCorrect:Boolean):void{
			var feedback:MovieClip = targetClip.getChildByName("feedback") as MovieClip;
			if(isCorrect){
				feedback.gotoAndStop(2);
			}else{
				feedback.gotoAndStop(1);
			}
			feedback.visible = true;
		}		
	}
}