﻿package com
{
	import flash.display.MovieClip;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import fl.transitions.Tween;
	import fl.transitions.easing.Strong;
	import fl.transitions.TweenEvent;
	public class EggTimer extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var ET:timer=new timer();
		private var anim_1:ET_30secs=new ET_30secs();
		private var anim_2:ET_1min=new ET_1min();
		private var anim_3:ET_2mins=new ET_2mins();
		private var Btn2:timer_30secs=new timer_30secs();
		private var Btn3:timer_1min=new timer_1min();
		private var Btn4:timer_2mins=new timer_2mins();
		private var CurrentAnimation:MovieClip=new MovieClip();
		private var sandTween:Tween;
		
		public function EggTimer()
		{
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO_F59.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			LoadAnimationFlip();
			AddButtons();
		}
		private function onReset(eve:MouseEvent=null):void{
			ET.scaleX =1;
			removeChild(CurrentAnimation);
			LoadAnimationFlip();
		}
		private function LoadAnimationFlip():void
		{
			CurrentAnimation= new MovieClip()
			CurrentAnimation.addChild(ET);
			addChild(CurrentAnimation);
			ET.x=XMLObj.Animation1.@xpos;
			ET.y=XMLObj.Animation1.@ypos;
			Btn2.gotoAndStop(1);
			Btn3.gotoAndStop(1);
			Btn4.gotoAndStop(1);
		}
		
		private function addeventlistener(target_mc):void{
			target_mc.addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
			target_mc.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
			target_mc.gotoAndStop(1);
		}
		private function removeeventlistener(target_mc):void{
			target_mc.removeEventListener(MouseEvent.MOUSE_OVER,onmouseover);
			target_mc.removeEventListener(MouseEvent.MOUSE_OUT,onmouseout);
		}
		private function onmouseover(eve:MouseEvent=null):void{
			var btn =eve.target;
			btn.gotoAndStop(2);
		}
		private function onmouseout(eve:MouseEvent=null):void{
			var btn =eve.target;
			btn.gotoAndStop(1);
		}
		private function AddButtons():void
		{
			addChild(Btn2);
			Btn2.x=XMLObj.Btn1.@xpos;
			Btn2.y=XMLObj.Btn1.@ypos;
			Btn2.mouseChildren = false;
			Btn2.buttonMode = true;
			addeventlistener(Btn2)
			Btn2.addEventListener(MouseEvent.CLICK,PlayAnimation1);
			
			addChild(Btn3);
			Btn3.x=XMLObj.Btn2.@xpos;
			Btn3.y=XMLObj.Btn2.@ypos;
			Btn3.mouseChildren = false;
			Btn3.buttonMode = true;
			addeventlistener(Btn3)
			Btn3.addEventListener(MouseEvent.CLICK,PlayAnimation2);
			
			addChild(Btn4);
			Btn4.x=XMLObj.Btn3.@xpos;
			Btn4.y=XMLObj.Btn3.@ypos;
			Btn4.mouseChildren = false;
			Btn4.buttonMode = true;
			addeventlistener(Btn4)
			Btn4.addEventListener(MouseEvent.CLICK,PlayAnimation3);

		}
		private function FlipTimer(e:MouseEvent):void
		{
			e.target.gotoAndStop(3);
			removeeventlistener(e.target);
			addeventlistener(Btn2);
			addeventlistener(Btn3);
			addeventlistener(Btn4);
			removeChild(CurrentAnimation);
			CurrentAnimation= new MovieClip()
			CurrentAnimation.addChild(ET);
			addChild(CurrentAnimation);
			ET.x=XMLObj.Animation1.@xpos;
			ET.y=XMLObj.Animation1.@ypos;
			sandTween=new Tween(ET,"scaleX",Strong.easeOut,-1,1,Number(XMLObj.Flip.@speed),true);
			sandTween.start();
			sandTween.addEventListener (TweenEvent.MOTION_CHANGE,onChange);
		}
		private function onChange(e:TweenEvent):void
		{
			if(ET.scaleX>=0)
			{
				sandTween.stop();
				sandTween.removeEventListener (TweenEvent.MOTION_CHANGE,onChange);
				removeChild(CurrentAnimation);
				CurrentAnimation = new MovieClip()
				CurrentAnimation.addChild(anim_3);		
				addChild(CurrentAnimation)
				anim_3.anim.gotoAndPlay(2);
				anim_3.x=XMLObj.Animation1.@xpos;
				anim_3.y=XMLObj.Animation1.@ypos;
				
			}
		
		}
		private function PlayAnimation1(e:MouseEvent):void
		{
			e.target.gotoAndStop(3);
			removeeventlistener(e.target);
			addeventlistener(Btn3);
			addeventlistener(Btn4);
			removeChild(CurrentAnimation);
			CurrentAnimation = new MovieClip()
			CurrentAnimation.addChild(anim_1);		
			addChild(CurrentAnimation)
			anim_1.anim.gotoAndPlay(2);
			anim_1.x=XMLObj.Animation1.@xpos;
			anim_1.y=XMLObj.Animation1.@ypos;
		}
		private function PlayAnimation2(e:MouseEvent):void
		{
			e.target.gotoAndStop(3);
			removeeventlistener(e.target);
			addeventlistener(Btn2);
			addeventlistener(Btn4);
			removeChild(CurrentAnimation);
			CurrentAnimation = new MovieClip()
			CurrentAnimation.addChild(anim_2);		
			addChild(CurrentAnimation)
			anim_2.anim.gotoAndPlay(2);
			anim_2.x=XMLObj.Animation1.@xpos;
			anim_2.y=XMLObj.Animation1.@ypos;
		}
		private function PlayAnimation3(e:MouseEvent):void
		{
			e.target.gotoAndStop(3);
			removeeventlistener(e.target);
			addeventlistener(Btn2);
			addeventlistener(Btn3);
			removeChild(CurrentAnimation);
			CurrentAnimation = new MovieClip()
			CurrentAnimation.addChild(anim_3);		
			addChild(CurrentAnimation)
			anim_3.anim.gotoAndPlay(2);
			anim_3.x=XMLObj.Animation1.@xpos;
			anim_3.y=XMLObj.Animation1.@ypos;
		}
	}
}