﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Loader;
	import flash.display.Shape;
	import flash.display.Stage;
	import flash.geom.Rectangle;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	import flash.text.TextFormatAlign;
	
	public class MorePositionWords extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var DragObj:MovieClip=new MovieClip();
		private var MCArray:Array=new Array();
		private var TotalWords:Number;
		private var Loadingmc:Loading_mc=new Loading_mc();
		
		private var swfw:Number=690;
		private var swfh:Number=500;
		
		public function MorePositionWords()
		{
			addChild(Loadingmc);
			Loadingmc.name="preloader";
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO_F13.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			var Len:Number=XMLObj.Words.Word.length();
			TotalWords=Len;
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
			LoadImages();
		}
		
		private function LoadImages(e:Event=null):void
		{
			if(XMLObj.BG.@imageURL!=undefined && XMLObj.BG.@imageURL!="")
			{
				LoadImage();
			}			
		}
		private function LoadImage():void
		{
			var LoaderObj:Loader=new Loader();
			LoaderObj.load(new URLRequest(XMLObj.BG.@imageURL));
			LoaderObj.contentLoaderInfo.addEventListener(Event.COMPLETE,onCompleteImageLoaded);
			addChild(LoaderObj);
			LoaderObj.x=XMLObj.BG.@imageX;
			LoaderObj.y=XMLObj.BG.@imageY;
			var percentage:int = 50;
			Loadingmc.loader_mc.gotoAndStop(percentage);
			Loadingmc.loader_mc.txt.text = "loading..."+percentage+"%";
		}
		private function onCompleteImageLoaded(e:Event):void
		{			
			if(getChildByName("preloader"))
			{
				removeChild(Loadingmc);
			}
			AddText();
		}
		private function AddText():void
		{
			for(var i:int=0;i<TotalWords;i++)
			{	
				var MC:MovieClip=new MovieClip();
				var la:label_mc=new label_mc();
				var TxtFld:TextField=new TextField();
				TxtFld.autoSize="left";
				TxtFld.selectable=false;
				TxtFld.multiline=false;					
				TxtFld.htmlText=XMLObj.Words.Word[i];
				TxtFld.antiAliasType=AntiAliasType.ADVANCED;
				
				var TF:TextFormat=new TextFormat();				
				var FontC=getDefinitionByName(XMLObj.Words.@FontId) as Class;
				var newFont:Font=new FontC();
				
				TF.font=newFont.fontName;	
				TF.size=XMLObj.Words.@FontSize;
				TF.color=XMLObj.Words.@FontColor;
				TxtFld.setTextFormat(TF);	
				TxtFld.embedFonts=true;			
				
				
				la.width=TxtFld.width;
				la.height=TxtFld.height;
				
				MC.addChild(la);
				MC.addChild(TxtFld);
				
				TxtFld.y = MC.height/2 - TxtFld.height/2;
				TxtFld.x = MC.width/2 - TxtFld.width/2;
				
				MC.x=XMLObj.Words.Word[i].@xpos;
				MC.y=XMLObj.Words.Word[i].@ypos;
				addChild(MC);
				MC.mouseChildren=false;
				MC.buttonMode=true;
				MC.name="Word"+i;
				MC.addEventListener(MouseEvent.MOUSE_DOWN,dragIt);
				MCArray.push(MC);
				MC.xpos=MC.x;
				MC.ypos=MC.y;
			}
			//var mc=getChildByName("Word0");
			//mc.addEventListener(MouseEvent.CLICK,Reset);
		}
		private function dragIt(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			DragObj=tar;
			setChildIndex(tar,numChildren-1);
			tar.startDrag(false,new Rectangle(17,0,swfw-tar.width,swfh-tar.height));
			stage.addEventListener(MouseEvent.MOUSE_UP,dropIt);
			tar.addEventListener(MouseEvent.MOUSE_UP,dropIt);
		}
		private function dropIt(e:MouseEvent):void
		{
			if(DragObj)
			{
				DragObj.stopDrag();
				stage.removeEventListener(MouseEvent.MOUSE_UP,dropIt);
				DragObj.removeEventListener(MouseEvent.MOUSE_UP,dropIt);
				DragObj=new MovieClip();
				
			}
		}
		public function onReset(evt:MouseEvent = null ):void {
			for(var i:int=0;i<MCArray.length;i++)
			{
				MCArray[i].x=MCArray[i].xpos;
				MCArray[i].y=MCArray[i].ypos;
			}
		}
		
		private function BringPreloaderToFront():void
		{
			setChildIndex(Loadingmc,numChildren-1);
		}
	}
}