﻿package {
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.net.*;
	import flash.utils.*;
	
	/**
	 * ...
	 * @author karthikeyan
	 */
	public class Counting extends MovieClip {
		var gridValue;
		var startVal;
		var incrementCountingArray;
		var XMLDatas;
		var XML_Loader;
		var startCountMc = new MovieClip();
		var dragObj;

		
		public function Counting() {
			loadXMLfile("xml/config.xml");
		}
		
		public function loadXMLfile(Path:String):void {
			XML_Loader = new URLLoader();
			XML_Loader.load(new URLRequest(Path));
			XML_Loader.addEventListener(Event.COMPLETE, getData);
		}
		
		private function getData(eve:Event) {
			XMLDatas = XML(XML_Loader.data);
			incrementCountingArray = XMLDatas.range.incrementCountingArray.val; // btn;//.@val.toXMLString().split("\n");
			
			
			gridValue = XMLDatas.range.grid;
			
			buildGrid();
			onReset();
		}
		
		function buildGrid() {
			var gridMc = new MovieClip();
			gridMc.name = "gridMc";
			
			var boxy = 0, boxx = 0;
			for (var i:int = gridValue.@StartValue; i <= gridValue.@EndValue; i++) {
				var boxClass = getDefinitionByName("NumberBox");
				var _box = new boxClass();
				
				boxx++;
				
				_box.x = boxx * _box.width;
				_box.y = boxy * _box.height;
				
				if (i!=0 && boxx==10) {
					boxy++;
					boxx = 0
				}
				
				_box.name = "Box_" + i;
				_box._txt.text = i;
				_box.mouseChildren = false;
				_box.addEventListener(MouseEvent.CLICK, onPattern);
				gridMc.addChild(_box);
			}
			addChild(gridMc);
			
			
			gridMc.x = gridValue.@xPos;
			gridMc.y = gridValue.@yPos;
			
			//_showbtn.mouseChildren = false;
			//_showbtn.addEventListener(MouseEvent.MOUSE_DOWN, onShowPattern);
			
			var reset_btn = getChildByName("reset_btn");
			reset_btn.addEventListener(MouseEvent.CLICK, onReset);
		}
		
		
		function onReset(eve=null):void 
		{
			var gridMc = getChildByName("gridMc");
			for (var j = gridValue.@StartValue; j <= gridValue.@EndValue; j++) {
				var boxCl = gridMc.getChildByName("Box_" + j);
				boxCl.gotoAndStop(1);
			}
			
			
			startVal=Math.floor(Math.random()*(1+99-1))+1;
			
			_label.text = incrementCountingArray[startVal-1];
			stat.gotoAndStop(1);
			//trace("now", startVal);
		}
		
		
		function onPattern(eve):void {
			
			trace(eve.target.name, startVal);
			
			var gridMc = getChildByName("gridMc");
			for (var j = gridValue.@StartValue; j <= gridValue.@EndValue; j++) {
				var boxCl = gridMc.getChildByName("Box_" + j);
				boxCl.gotoAndStop(1);
			}
			
			
			eve.target.gotoAndStop(2);
			if (Number(eve.target.name.split("_")[1]) == startVal)
			{
				stat.gotoAndStop(3);
			}else {
				stat.gotoAndStop(2);
			}
		}

	
	}
}