﻿package com{
	import flash.display.MovieClip;
	import flash.events.*;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.geom.ColorTransform;
	import flash.geom.Rectangle;
	import flash.utils.Timer;
    import flash.events.TimerEvent;
	
	import flash.text.Font;
	import flash.utils.getDefinitionByName;

	public class Dice {
		private var targetClip:MovieClip;
		private var xmlData:XML;
		private var diceCount:Number;
		private var resultArr:Array;
		private var diceArr:Array;
		private var timerCount:Number;
		private var clickedCount:Number;
		private var type:String;
		
		public function Dice(target:MovieClip):void {
			targetClip = target;
			targetClip.visible = false;
			xmlData = new XML();
			diceCount = 1;
			clickedCount = 0;
			resultArr = new Array();
			diceArr = new Array();
		}
		public function setUp(url:String):void {
			enableBtns(false);
			loadXML(url);
		}	
		var leftMc:Number
		var rightMc:Number
		var centerMc:Number
		private function randomRange(prevRndNum:Number,max:Number, min:Number = 0, type:String=''):Number
		{
			if(max == min) return max;
			var currRnd:Number = Math.round(Math.random() * (max - min) + min);
			var prevRnd:Number = prevRndNum;
			if (prevRnd == currRnd) {
				
				currRnd = randomRange(prevRnd,max,min,type);
			}
			if (type == "center")
			{
				centerMc = currRnd
			}
			if (type == "left")
			{
				leftMc = currRnd
			}
			if (type == "right")
			{
				rightMc = currRnd
				
			}
			if ((leftMc == rightMc) || (centerMc == leftMc) || ((centerMc == rightMc)))
			{
				currRnd = randomRange(prevRnd,max,min,type);
			}			
			return currRnd;
		}				
		private function enableBtns(val:Boolean):void{
			targetClip.reset_btn.enabled = val;
			targetClip.showResultBtn.enabled = val;
			targetClip.rollBtn.enabled = val;
			targetClip.dotBtn.enabled = val;
			targetClip.wordBtn.enabled = val;
			targetClip.numBtn.enabled = val;
			
			if(val){
				targetClip.reset_btn.addEventListener(MouseEvent.CLICK,onReset);
				
				for(var i:Number=0;i<4;i++){
					if(i<xmlData.dices.children().length()){
						targetClip["btn_"+i].buttonMode = true;
						targetClip["btn_"+i].mouseChildren = false;
						targetClip["btn_"+i].gotoAndStop(1);
						targetClip["btn_"+i].visible = true;
						targetClip["btn_"+i].addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
						targetClip["btn_"+i].addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
						targetClip["btn_"+i].addEventListener(MouseEvent.CLICK,onBtnClicked);
					}else{
						targetClip["btn_"+i].visible = false;
					}
				}			
				targetClip.showResultBtn.mouseChildren = false;
				targetClip.showResultBtn.buttonMode = true;					
				targetClip.showResultBtn.gotoAndStop(1);
				targetClip.showResultBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
				targetClip.showResultBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
				targetClip.showResultBtn.addEventListener(MouseEvent.CLICK,function(){
					targetClip.showResultBtn.gotoAndStop(3);
					targetClip.showResultBtn.removeEventListener(MouseEvent.MOUSE_OVER,onmouseover);
					targetClip.showResultBtn.removeEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					showHideResult();
				});
				targetClip.rollBtn.mouseChildren = false;
				targetClip.rollBtn.buttonMode = true;
				targetClip.rollBtn.gotoAndStop(1);
				targetClip.rollBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
				targetClip.rollBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
				targetClip.rollBtn.addEventListener(MouseEvent.MOUSE_DOWN,onmousedown);
				targetClip.rollBtn.addEventListener(MouseEvent.MOUSE_UP,onmouseup);
				targetClip.rollBtn.addEventListener(MouseEvent.CLICK,function(e:MouseEvent){
					clickedCount++;
					if(clickedCount==1){
						resultArr[0].val = Number(resultArr[0].val) + 1;
						showResult(0);
					}
					var dicesClip:MovieClip = targetClip.getChildByName("dicesClip") as MovieClip;
					timerCount = 0;
					for(i=0;i<diceCount;i++){
						var diceClip:MovieClip = dicesClip.getChildByName("diceClip_"+i) as MovieClip;	
							diceClip.addEventListener(Event.ENTER_FRAME,startAnimation);
					}
				});
				targetClip.dotBtn.mouseChildren = false;
				targetClip.dotBtn.buttonMode = true;
				targetClip.dotBtn.gotoAndStop(1);
				targetClip.dotBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
				targetClip.dotBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
				targetClip.dotBtn.addEventListener(MouseEvent.CLICK,function(){
					targetClip.dotBtn.removeEventListener(MouseEvent.MOUSE_OVER,onmouseover);
					targetClip.dotBtn.removeEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.wordBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
					targetClip.wordBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.numBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
					targetClip.numBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.dotBtn.gotoAndStop(3);  
					targetClip.wordBtn.gotoAndStop(1);
					targetClip.numBtn.gotoAndStop(1);
					addDice();
					updateResultArr();
				});
				targetClip.wordBtn.mouseChildren = false;
				targetClip.wordBtn.buttonMode = true;
				targetClip.wordBtn.gotoAndStop(1);
				targetClip.wordBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
				targetClip.wordBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
				targetClip.wordBtn.addEventListener(MouseEvent.CLICK,function(){
					targetClip.wordBtn.removeEventListener(MouseEvent.MOUSE_OVER,onmouseover);
					targetClip.wordBtn.removeEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.dotBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
					targetClip.dotBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.numBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
					targetClip.numBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.dotBtn.gotoAndStop(1);  
					targetClip.wordBtn.gotoAndStop(3);
					targetClip.numBtn.gotoAndStop(1);
					addDice();
					updateResultArr();
				});
				targetClip.numBtn.mouseChildren = false;
				targetClip.numBtn.buttonMode = true;
				targetClip.numBtn.gotoAndStop(1);
				targetClip.numBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
				targetClip.numBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
				targetClip.numBtn.addEventListener(MouseEvent.CLICK,function(){
					targetClip.numBtn.removeEventListener(MouseEvent.MOUSE_OVER,onmouseover);
					targetClip.numBtn.removeEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.dotBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
					targetClip.dotBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.wordBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
					targetClip.wordBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					targetClip.dotBtn.gotoAndStop(1);  
					targetClip.wordBtn.gotoAndStop(1);
					targetClip.numBtn.gotoAndStop(3);
					addDice();
					updateResultArr();
				});
			}
		}
		private function onReset(eve:MouseEvent=null):void{
			reset();
			targetClip.showResultBtn.gotoAndStop(1);
					targetClip.showResultBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
					targetClip.showResultBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					showHideResult();
			
		}
		private function onmouseover(eve:MouseEvent=null):void{
			var btn = eve.target;
			btn.gotoAndStop(2);
			
		}
		private function onmouseout(eve:MouseEvent=null):void{
			var btn = eve.target;
			btn.gotoAndStop(1);
			
		}
		private function onmousedown(eve:MouseEvent=null):void{
			var btn = eve.target;
			btn.gotoAndStop(3);
			
		}
		private function onmouseup(eve:MouseEvent=null):void{
			var btn = eve.target;
			btn.gotoAndStop(1);
			
		}
		private function showHideResult(){
			var resultClip:MovieClip = targetClip.getChildByName("resultClip") as MovieClip;
			if(resultClip!=null){
				if(resultClip.visible == false){
					resultClip.visible = true;
					
				}else{
					resultClip.visible = false;
					targetClip.showResultBtn.gotoAndStop(1);
					targetClip.showResultBtn.addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
					targetClip.showResultBtn.addEventListener(MouseEvent.MOUSE_OUT,onmouseout);
					
				}
			}
		}
		var index1
		var index2
		var index3
		private function startAnimation(e:Event):void{
			var id:Number = Number(e.target.name.split("_")[1]);
			var dicesClip:MovieClip = targetClip.getChildByName("dicesClip") as MovieClip;
			var diceClip:MovieClip = dicesClip.getChildByName("diceClip_"+id) as MovieClip;
			diceClip.removeEventListener(Event.ENTER_FRAME,startAnimation); 
			var myTimer:Timer = new Timer(100,10);			
			myTimer.addEventListener(TimerEvent.TIMER, function(){rollDice(diceClip);});	
			myTimer.addEventListener(TimerEvent.TIMER_COMPLETE,function(){
				timerCount++;				
				if(timerCount == (clickedCount*diceCount)){
					clickedCount = 0;
					var totalCount:Number = 0;
					for(var i=0;i<diceArr.length;i++){
						totalCount += diceArr[i];
					}
					var id:Number = getIndex(totalCount);
					resultArr[id].val = Number(resultArr[id].val) + 1;
					showResult(id);
					diceArr = [];
					
					
					
				}
			});
			myTimer.start();
		}
		private function getIndex(num:Number):Number{
			var id:Number;
			for(var i=0;i<resultArr.length;i++){				
				if(resultArr[i].id == num){
					id = i;
					break;
				}
			}
			return id;
		}
		private function rollDice(diceClip:MovieClip):void{	
			var id:Number = Number(diceClip.name.split("_")[1]);
			var len:Number;
			if(type=="sixsided"){
				len = 5;
			}else{
				len = 9;
			}
			var rolledNum:Number = randomRange(Number(diceArr[id]),0,len,"center");
			diceArr[id] = rolledNum + 1;
			drawPageContent(rolledNum,diceClip.top);
			drawPageContent(randomRange(Number(diceArr[id]),0,len,"left"),diceClip.left);
			drawPageContent(randomRange(Number(diceArr[id]),0,len,"right"), diceClip.right);
			
		}
		private function onBtnClicked(e:MouseEvent):void{
			diceArr = [];
				for(var i:Number=0;i<4;i++){
					   targetClip["btn_"+i].gotoAndStop(1);
					   targetClip["btn_"+(diceCount-1)].mouseEnabled = true;
						targetClip["btn_"+i].addEventListener(MouseEvent.MOUSE_OVER,onmouseover);
						targetClip["btn_"+i].addEventListener(MouseEvent.MOUSE_OUT,onmouseout);

				}			
			
			if("btn_"+(diceCount-1) != e.target.name){
				clickedCount = 0;
				targetClip["btn_"+(diceCount-1)].gotoAndStop(1);				
				diceCount = Number(e.target.name.split("_")[1]) + 1;				
				addDice();			
				targetClip["btn_"+(diceCount-1)].gotoAndStop(3);
				targetClip["btn_"+(diceCount-1)].mouseEnabled = false;
				targetClip["btn_"+(diceCount-1)].removeEventListener(MouseEvent.MOUSE_OVER,onmouseover);
				targetClip["btn_"+(diceCount-1)].removeEventListener(MouseEvent.MOUSE_OUT,onmouseout);
				updateResultArr();
			}
		}
		private function updateResultArr():void {
			var len:Number;
			if(type=="sixsided"){
				len = 6;
			}else{
				len = 10;
			}
			resultArr = [];
			resultArr[0] = ({id:"Roll",val:0});
			for(var i=diceCount;i<=(diceCount * len);i++){	
				var index:Number = (i-diceCount) + 1;				
				resultArr[index] = ({id:i,val:0});					
			}
			drawResult();
		}
		private function loadXML(path:String) {
			var urlRequest:URLRequest=new URLRequest(path);
			var urlLoader:URLLoader=new URLLoader(urlRequest);
			urlLoader.addEventListener(Event.COMPLETE, xmlLoaded);
		}
		private function xmlLoaded(e:Event):void {
			xmlData = new XML(e.target.data);
			enableBtns(true);
			type = xmlData.@type.toLowerCase();
			reset();
			showHideResult();
			targetClip.visible = true;
			targetClip.showResultBtn.visible = false
		}
		public function reset():void {
			clickedCount = 0;
			targetClip["dotBtn"].dispatchEvent(new MouseEvent(MouseEvent.CLICK));
			targetClip["btn_0"].dispatchEvent(new MouseEvent(MouseEvent.CLICK));
			targetClip["btn_0"].gotoAndStop(3);
			targetClip["btn_0"].removeEventListener(MouseEvent.MOUSE_OVER,onmouseover);
			targetClip["btn_0"].removeEventListener(MouseEvent.MOUSE_OUT,onmouseout);
			targetClip.showResultBtn.dispatchEvent(new MouseEvent(MouseEvent.CLICK))
		}		
		private function resizePage(page:MovieClip, w:Number, h:Number):void {
			page.bg.x=0;
			page.bg.y=0;
			page.bg.width=w;
			page.bg.height=h;			
			//if (page.border.visible) {
				page.border.right.height=h;
				page.border.top.width=w;
				page.border.left.height=h;
				page.border.bottom.width=w;

				page.border.left.x=0;
				page.border.left.y=0;
				page.border.top.x=0;
				page.border.top.y=0;

				page.border.right.x=page.border.top.x+page.border.top.width-page.border.right.width;
				page.border.right.y=0;
				page.border.bottom.x=0;
				page.border.bottom.y=page.border.left.y+page.border.left.height-page.border.bottom.height;
			//}
		}
		private function drawPage(w:Number, h:Number, fillColor:Number, fillAlpha:Number, borderSize:Number, borderColor:Number):MovieClip {
			var page:Page = new Page();
			var pageColorTrans:ColorTransform = new ColorTransform();
			pageColorTrans.color=fillColor;
			page.bg.transform.colorTransform=pageColorTrans;
			page.bg.alpha=fillAlpha;
			page.border.visible = (borderSize>0) ? true : false;
			if (page.border.visible) {
				var borderColorTrans:ColorTransform = new ColorTransform();
				borderColorTrans.color=borderColor;
				page.border.transform.colorTransform=borderColorTrans;

				page.border.left.width=borderSize;
				page.border.right.width=borderSize;
				page.border.top.height=borderSize;
				page.border.bottom.height=borderSize;
			}
			resizePage(page,w,h);
			return page;
		}
		private function drawDice(fillColor:Number,shadowColor:Number, fillAlpha:Number, borderSize:Number, borderColor:Number):MovieClip {
			var diceObj;
			if(type=="sixsided") diceObj = new dice();
			else diceObj = new diamond();
			var diceColorTrans:ColorTransform = new ColorTransform();
			diceColorTrans.color = fillColor;
			diceObj.top.bg.transform.colorTransform = diceColorTrans;
			var shadowColorTrans:ColorTransform = new ColorTransform();
			shadowColorTrans.color = shadowColor;
			diceObj.left.bg.transform.colorTransform = diceObj.right.bg.transform.colorTransform = shadowColorTrans;
			diceObj.top.bg.alpha = diceObj.left.bg.alpha = diceObj.right.bg.alpha = fillAlpha;
			diceObj.top.border.visible = diceObj.left.border.visible = diceObj.right.border.visible = (borderSize>0) ? true : false;
			if (borderSize>0) {
				var borderColorTrans:ColorTransform = new ColorTransform();
				borderColorTrans.color=borderColor;
				diceObj.top.border.transform.colorTransform=diceObj.left.border.transform.colorTransform=diceObj.right.border.transform.colorTransform=borderColorTrans;

			}
			return diceObj;
		}
		private function addDice():void {
			if(targetClip.getChildByName("dicesClip")!=null) targetClip.removeChild(targetClip.getChildByName("dicesClip"));
			var dicesClip:MovieClip = new MovieClip(); 
			dicesClip.name = "dicesClip";
			var row:Number = Number(xmlData.dices.@row);
			var col:Number = Number(xmlData.dices.@col);
			var gap:Number = Number(xmlData.dices.@gap);
			for(var i=0;i<diceCount;i++){
				var diceClip:MovieClip = drawDice(Number(xmlData.dices.dice[i].@bgColor),Number(xmlData.dices.dice[i].@shadowColor), ((xmlData.dices.dice[i].@bgColor=="")?0:1), Number(xmlData.dices.dice[i].@borderSize), Number(xmlData.dices.dice[i].@borderColor));
				diceClip.name="diceClip_"+i;
				diceArr[i] = 0;
				
				if(type=="sixsided"){
					if(xmlData.dices.@sixDiceWidth.toString().length>0) diceClip.width = Number(xmlData.dices.@sixDiceWidth);
					if(xmlData.dices.@sixDiceHeight.toString().length>0) diceClip.height = Number(xmlData.dices.@sixDiceHeight);
					drawPageContent(4,diceClip.left);
					drawPageContent(3,diceClip.right);					
				}else{
					if(xmlData.dices.@tenDiceWidth.toString().length>0) diceClip.width = Number(xmlData.dices.@tenDiceWidth);
					if(xmlData.dices.@tenDiceHeight.toString().length>0) diceClip.height = Number(xmlData.dices.@tenDiceHeight);
					drawPageContent(0,diceClip.left);
					drawPageContent(0,diceClip.right);
				}
				diceClip.x = (i%col) * (diceClip.width + gap);
				diceClip.y = (Math.floor(i/col) * (diceClip.height + gap));
				drawPageContent(0,diceClip.top);
				dicesClip.addChild(diceClip);
			}
			dicesClip.x = (xmlData.dices.@x.toString().length>0) ? Number(xmlData.dices.@x) : ((targetClip.boundary.width - dicesClip.width)/2);
			dicesClip.y = Number(xmlData.dices.@y);
			targetClip.addChild(dicesClip);
		}
		private function changeFormat(targetTxt:TextField,font:String,fontSize:Number,fontColor:uint,align:String=null):void{
			var txt:TextField = targetTxt;
			var txtFormat:TextFormat = new TextFormat();
			txtFormat.leftMargin = 0;
			txtFormat.rightMargin = 0;
			txtFormat.font = font;
			//txtFormat.bold = true;			
			txtFormat.size = fontSize;
			txtFormat.color = fontColor;
			if(align!=null) txtFormat.align = align;
			txt.setTextFormat(txtFormat);
			txt.embedFonts=true;
		}
		private function addTxt(txtStr:String):TextField{
			var txt:TextField = new TextField();
			txt.selectable = false;
			txt.background = false;
			txt.border = false;
			txt.autoSize = TextFieldAutoSize.LEFT;
			txt.text = txtStr;
			return txt;
		}
		private function drawPageContent(pageNo:Number,targetPage:MovieClip):void {				
			var str:String = (targetClip.wordBtn.currentFrame==3) ? xmlData.contents.content[pageNo].@word : xmlData.contents.content[pageNo].@no;
			var diceType:String = (type=="sixsided") ? "six" : "ten";		
			var contentType:String = (targetClip.wordBtn.currentFrame==3) ? "word" : (targetClip.numBtn.currentFrame==3) ? "number" : "dots";
			var contentData:XMLList = xmlData.contents.content[pageNo].child(diceType).child(targetPage.name).child(contentType);
			var parentClip:MovieClip = targetPage.parent as MovieClip;
			var pageCont:MovieClip = targetPage.getChildByName("pageCont") as MovieClip;
			if(pageCont!=null) targetPage.removeChild(pageCont);
			pageCont = new MovieClip();
			pageCont.name="pageCont";
						
			if (contentType=="dots") {
				var numOfContents:Number=contentData.children().length();				
				if (numOfContents>0) {
					for (var j:Number=0; j<numOfContents; j++) {
						var cont:MovieClip = new MovieClip();
						cont.name="cont_"+j;						
						cont.graphics.lineStyle(Number(contentData.dot[j].@borderSize), Number(contentData.dot[j].@borderColor), (Number(contentData.dot[j].@borderSize)==0)?0:1);
						cont.graphics.beginFill(Number(contentData.dot[j].@bgColor), 1);
						cont.graphics.drawEllipse(0,0,Number(contentData.dot[j].@width),Number(contentData.dot[j].@height));
						var xDist:Number=Number(contentData.dot[j].@x);
						var yDist:Number=Number(contentData.dot[j].@y);
						cont.x = xDist;
						cont.y = yDist;
						cont.rotation = (contentData.dot[j].@rotation.toString().length>0) ? Number(contentData..dot[j].@rotation) : 0;
						
						pageCont.addChild(cont);
					}
					pageCont.x = 0;
					pageCont.y = 0;
				}
			}else{
				var txt:TextField = addTxt(str);
				txt.name="txt";
				txt.embedFonts = true;
				
				var fnt=getDefinitionByName(contentData.@font) as Class;
				var fon:Font=new fnt();
				
				changeFormat(txt,fon.fontName,Number(contentData.@fontSize),uint(contentData.@fontColor));
				pageCont.x = Number(contentData.@x);
				pageCont.y = Number(contentData.@y);
				pageCont.rotation = (contentData.@rotation.toString().length>0) ? Number(contentData.@rotation) : 0;
				if((targetPage.name=="right" && targetClip.dotBtn.currentFrame==3) || (diceType=="ten" && targetPage.name=="right")){
					pageCont.scaleX *= -1;
				}
				pageCont.addChild(txt);					
			}		
			targetPage.addChild(pageCont);
			targetPage.mouseChildren=false;
		}
		private function drawResult():void{
			if(targetClip.getChildByName("resultClip")!=null) targetClip.removeChild(targetClip.getChildByName("resultClip"));		
			var resultClip:MovieClip = new MovieClip();
			resultClip.name = "resultClip";
			var xPos:Number = 0;
			var yPos:Number = 0;
			var counter:Number;
			for(var i=0;i<resultArr.length;i++){
				var left:MovieClip = drawPage(Number(xmlData.answer.@width), Number(xmlData.answer.@height), Number(xmlData.answer.@bgColor),((xmlData.answer.@bgColor=="")?0:1), Number(xmlData.answer.@borderSize), Number(xmlData.answer.@borderColor));
				left.name = "left_"+i;
				var txt1:TextField = addTxt(resultArr[i].id);
				txt1.name="txt";
				
				var fnt=getDefinitionByName(xmlData.answer.@font) as Class;
				var fon:Font=new fnt();
				
				changeFormat(txt1,fon.fontName,Number(xmlData.answer.@fontSize),uint(xmlData.answer.@fontColor));
				left.addChild(txt1);				
				if(type=="sixsided"){
					if(resultArr.length>20){
						yPos = i%(resultArr.length/2);
						xPos = (i==0) ? i : Math.floor((i/(resultArr.length/2))%i);					
					}else{						
						xPos = 0;
						yPos = i;
					}
				}else{
					var lastIndex:Number;
					if(resultArr.length>30){
						lastIndex = 22;						
					}else if(resultArr.length>20){
						lastIndex = 21;
					}else{
						lastIndex = -1;						
					}
					
					if(lastIndex == -1){
						xPos = 0;
						yPos = i;
					}else{
						if(resultArr[i].id==lastIndex){
							counter = 0;					
						}
						if(resultArr[i].id>=lastIndex){
							xPos = 1;
							yPos = counter++;
						}else{
							xPos = 0;
							yPos = i;
						}
					}	
					
				}
				if(yPos==0){
					left.border.top.visible = true;
				}else{
					left.border.top.visible = false;
				}
				left.x = xPos * (2 * left.width + 20);
				left.y = yPos * Number(xmlData.answer.@height);
				if(txt1.text!=="Roll"){
					txt1.x = (left.width - txt1.width)/2 ;
				}else{
					trace("coming here:");
					txt1.x = 2
				}
				txt1.y = (left.height - txt1.height)/2;
				resultClip.addChild(left);
				
				var right:MovieClip = drawPage(Number(xmlData.answer.@width), Number(xmlData.answer.@height), Number(xmlData.answer.@bgColor),((xmlData.answer.@bgColor=="")?0:1), Number(xmlData.answer.@borderSize), Number(xmlData.answer.@borderColor));
				right.name = "right_"+i;
				var txt2:TextField = addTxt("0");
				txt2.name="txt";		
				txt2.visible = false;
				right.addChild(txt2);
				if(yPos==0){
					right.border.top.visible = true;
				}else{
					right.border.top.visible = false;
				}
				if(resultArr.length>20){
				}
				right.border.left.visible = false;
				right.x = left.x + left.width;
				right.y = left.y;
				txt2.x = (right.width - txt2.width)/2;
				//txt2.y = (right.height - txt2.height)/2;
				resultClip.addChild(right);				
				trace(txt2.y);
			}
			resultClip.x = Number(xmlData.answer.@x);
			resultClip.y = Number(xmlData.answer.@y);
			targetClip.addChild(resultClip);
			showResult(0);
			showHideResult();
		}
		private function showResult(index:Number):void{
			var resultClip:MovieClip = targetClip.getChildByName("resultClip") as MovieClip;
			var right:MovieClip = resultClip.getChildByName("right_"+index) as MovieClip;
			var txt:TextField = right.getChildByName("txt") as TextField;
			txt.text = resultArr[index].val.toString();
			txt.x = (right.width - txt.width)/2;
			txt.y = 3;
			var fnt=getDefinitionByName(xmlData.answer.@font) as Class;
			var fon:Font=new fnt();
			changeFormat(txt,fon.fontName,Number(xmlData.answer.@fontSize),uint(xmlData.answer.@fontColor));
			txt.visible = true;
		}
	}
}