﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Shape;
	import flash.display.Graphics;
	import flash.display.Loader;
	
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.text.TextFormatAlign;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	public class Money extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var LoaderMC:preloader_mc=new preloader_mc();
		private var TotalImages:Number=0;
		private var LoadedImageCount:Number=0;
		private var RowsCount:Number=0;
		private var ColsCount:Number=0;
		private var ImagesArray:Array=new Array();
		private var totalMoney:Number;
		private var Btn1:UnitedStates=new UnitedStates();
		private var Btn2:Japan=new Japan();
		private var Btn3:China=new China();
		private var Btn4:India=new India();
		private var Btn5:Europe=new Europe();
		private var Btn6:NewZealand=new NewZealand();
		private var Btn7:Random=new Random();
		private var Btn8:All=new All();
		private var DragObj:MovieClip=new MovieClip();
		private var moneyLoaded = 1;
		private var checkBtn:Check;
		private var sw:Number=760;
		private var sh:Number=530;
		private var totalAusCoins = 0;
		private var fCoinSelect = 0;
		private var nfCoinSelect = 0;
		private var myFeedBack:Feedback;
		private var shuffledArray:Array = new Array();
		public function Money()
		{		
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/NTO4_18.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			AddMoney();
			/*AddButton();
			AddFeedback();*/
			//FindTotalImages();
			//CreateMoneyImages();				
		}
		private function AddMoney(){
			totalMoney = XMLObj.AllMoney.Money.length();
			var imgPath = XMLObj.AllMoney.Money[moneyLoaded-1].@url;
			shuffledArray = fnShuffleArray();
			loadMoney(imgPath);
		}
		private function fnShuffleArray():Array
		{			
			var shuffledLetters:Array = new Array(totalMoney); 
			var emptySlots:Array = new Array();
			for (var n:int = 0; n < totalMoney; n++){    
				emptySlots.push(n);
			} 
			var randomPos:Number = 0;
			var actualSlot:Number = 0;
			for (var i:int = 0; i < totalMoney; i++){    
				randomPos = int(Math.random() * emptySlots.length); 
				actualSlot = emptySlots[randomPos];    
				shuffledLetters[actualSlot] = i;    
				emptySlots.splice(randomPos, 1);
			}
			return shuffledLetters;
		}
		private function AddButton(){
			checkBtn = new Check;
			checkBtn.x = XMLObj.Buttons.Btn.@xpos;
			checkBtn.y = XMLObj.Buttons.Btn.@ypos;
			checkBtn.addEventListener(MouseEvent.CLICK, onCheckFunc);
			addChild(checkBtn);
			reset_btn.addEventListener(MouseEvent.CLICK, onResetFunc);
		}
		private function onResetFunc(obj:MouseEvent){
			myFeedBack.visible=false;
			fCoinSelect = 0;
			nfCoinSelect = 0;
			shuffledArray = fnShuffleArray();
			for(var i=1; i<=totalMoney; i++){
				var myMoney = getChildByName("myCoin"+i);				
				myMoney.x = XMLObj.AllMoney.Money[shuffledArray[i-1]].@xpos;
				myMoney.y = XMLObj.AllMoney.Money[shuffledArray[i-1]].@ypos; 
				myMoney.mouseEnabled = true;
				myMoney.visible = true;
			}
		}
		private function onCheckFunc(obj:MouseEvent){
			if(nfCoinSelect==0 && fCoinSelect==(totalMoney-totalAusCoins)){
				myFeedBack.gotoAndStop(2);
			}else{
				myFeedBack.gotoAndStop(1);
			}
			myFeedBack.visible=true;
			for(var i=1; i<=totalMoney; i++){
				var myMoney = getChildByName("myCoin"+i);
				myMoney.mouseEnabled = false;
			}
		}
		private function AddFeedback(){
			myFeedBack = new Feedback;
			myFeedBack.x = XMLObj.FeedBack.@xpos;
			myFeedBack.y = XMLObj.FeedBack.@ypos;
			myFeedBack.visible = false;
			addChild(myFeedBack);
		}
		private function loadMoney(path:String){
			var LoaderObj:Loader=new Loader();
			LoaderObj.load(new URLRequest(path));
			LoaderObj.contentLoaderInfo.addEventListener(Event.COMPLETE, onImageLoadComplete);
		}
		private function onImageLoadComplete(evt:Event){
			var myImage:MovieClip = new MovieClip();
			myImage.name = "myCoin"+moneyLoaded;
			myImage.x =  XMLObj.AllMoney.Money[shuffledArray[moneyLoaded-1]].@xpos;
			myImage.y =  XMLObj.AllMoney.Money[shuffledArray[moneyLoaded-1]].@ypos;
			myImage.isFor = XMLObj.AllMoney.Money[moneyLoaded-1].@isForeign;
			if(XMLObj.AllMoney.Money[moneyLoaded-1].@isForeign == "No"){
				totalAusCoins++;
			}
			myImage.addChild(evt.target.content);
			myImage.visible = false;
			addChild(myImage);
			moneyLoaded++;
			if(moneyLoaded<=totalMoney){
				var imgPath = XMLObj.AllMoney.Money[moneyLoaded-1].@url;
				loadMoney(imgPath);
			}else{
				showAllMoney();
				AddButton();
				AddFeedback();
			}
		}
		private function showAllMoney(){
			for(var i=1; i<=totalMoney; i++){
				var myMoney = getChildByName("myCoin"+i);
				myMoney.visible = true;
				myMoney.buttonMode = true;
				myMoney.addEventListener(MouseEvent.CLICK, onMoneyClick);
			}
		}
		private function onMoneyClick(obj:MouseEvent){
			if(obj.currentTarget.isFor == "Yes"){
				fCoinSelect++;
			}else{
				nfCoinSelect++;
			}
			obj.currentTarget.visible = false;
		}
		private function AddBottomPanel():void
		{
			var sh:Shape=new Shape();
			var g:Graphics=sh.graphics;
			g.lineStyle(XMLObj.BottomPanel.@linethickness,XMLObj.BottomPanel.@linecolor);
			g.drawRect(0,0,XMLObj.BottomPanel.@width,XMLObj.BottomPanel.@height);
			addChild(sh);
			sh.x=XMLObj.BottomPanel.@xpos;
			sh.y=XMLObj.BottomPanel.@ypos;
		}
		private function FindTotalImages():void
		{
			var Rows:Number=XMLObj.Money.length();
			for(var i:int=0;i<Rows;i++)
			{
				var Obj:Object=new Object();
				Obj.images=new Array();
				ImagesArray.push(Obj);
				var Cols:Number=XMLObj.Money[i].Image.length();
				TotalImages+=Cols;
			}
		}
		private function LoadImages():void
		{
			if(LoadedImageCount<TotalImages)
			{
				var ImPath:String=XMLObj.Money[RowsCount].Image[ColsCount].@url;		
			
				LoadImage(ImPath);
			}
			if(LoadedImageCount==TotalImages)
			{
				//AddBottomPanel();
				AddAllButtons();
				//AddResetBtn();
				removeChild(LoaderMC);
			}
		}
		private function LoadImage(path:String):void
		{
			var LoaderObj:Loader=new Loader();
			LoaderObj.load(new URLRequest(path));
			LoaderObj.contentLoaderInfo.addEventListener(Event.COMPLETE,onImageLoaded);
		}
		private function onImageLoaded(e:Event):void
		{
			var tar=e.target.loader;
			var mc:MovieClip=new MovieClip();
			var sh:Shape=new Shape();
			mc.addChild(sh);
			
			var con=tar.content;
			mc.addChild(con);
			
			var g:Graphics=sh.graphics;
			g.lineStyle(XMLObj.ImageSettings.@outlinethickness,XMLObj.ImageSettings.@outlineColor,0);
			//g.beginFill(XMLObj.ImageSettings.@fillColor,1);
			g.drawRect(-2,-2,mc.width+4,mc.height+4);
			g.endFill();
			addChild(mc);
			
			mc.x=XMLObj.Money[RowsCount].Image[ColsCount].@xpos;
			mc.y=XMLObj.Money[RowsCount].Image[ColsCount].@ypos;		
			mc.xpos=mc.x;
			mc.ypos=mc.y;
			
			mc.visible=false;
			
			if(ColsCount==(XMLObj.Money[RowsCount].Image.length()-1))
			{
				ImagesArray[RowsCount].images.push(mc);
				RowsCount++;
				ColsCount=0;
			}else
			{
				ImagesArray[RowsCount].images.push(mc);
				ColsCount++;
			}
			LoadedImageCount++;
			
			setChildIndex(LoaderMC,numChildren-1);
			
			var percentage:int = int((LoadedImageCount/TotalImages)*100);
			if ( percentage < 100 ) {
				LoaderMC.gotoAndStop(percentage);
				LoaderMC.txt.text = "loading..."+percentage+"%";
			} 
			mc.addEventListener(MouseEvent.MOUSE_DOWN,DragIt);
			mc.mouseChildren=false;
			mc.buttonMode=true;
			
			LoadImages();
		}
		private function CreateTextField():TextField
		{
			var TxtFld:TextField=new TextField();
			TxtFld.name="txt";
			TxtFld.type="dynamic";
			TxtFld.selectable=false;
			TxtFld.multiline=false;	
			TxtFld.autoSize="left";
			
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.Words.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.Words.@FontSize;
			TF.color=XMLObj.Words.@FontColor;

			TxtFld.defaultTextFormat=TF;	
			TxtFld.embedFonts=true;
			
			return TxtFld;
			
		}
		private function CreateMoneyImages():void
		{
			
			addChild(LoaderMC);
			LoaderMC.x=(sw)/2;
			LoaderMC.y=(sh)/2;
			
			LoadImages();
		}
		private function AddAllButtons():void
		{
			for(var i:int=1;i<=XMLObj.Buttons.Btn.length();i++)
			{
				var Btn=addChild(this["Btn"+i]);
				Btn.name="btn_"+(i-1);
				Btn.x=XMLObj.Buttons.Btn[i-1].@xpos;
				Btn.y=XMLObj.Buttons.Btn[i-1].@ypos;
				Btn.addEventListener(MouseEvent.CLICK,showMoney);
			}
			
		}
		private function showMoney(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			var Index=Number(tar.name.split("_")[1]);			
			switch(Index)
			{
				case 0:
				case 1:
				case 2:
				case 3:
				case 4:
				case 5:
					for(var i:int=0;i<ImagesArray.length;i++)
					{
						for(var j:int=0;j<ImagesArray[i].images.length;j++)
						{
							ImagesArray[i].images[j].visible=false;
						}
					}
					
					for(i=0;i<ImagesArray[Index].images.length;i++)
					{
						ImagesArray[Index].images[i].visible=true;
						ImagesArray[Index].images[i].x=ImagesArray[Index].images[i].xpos;
						ImagesArray[Index].images[i].y=ImagesArray[Index].images[i].ypos;
					}
					break;
				case 6:
					var Num:Number=randomRange(0,5);
					for(i=0;i<ImagesArray.length;i++)
					{
						for(j=0;j<ImagesArray[i].images.length;j++)
						{
							ImagesArray[i].images[j].visible=false;
						}
					}
					var rndCur:Number=randomRange(0,ImagesArray[Num].images.length-1);					
					ImagesArray[Num].images[rndCur].visible=true;
					ImagesArray[Num].images[rndCur].x = 760/2 - ImagesArray[Num].images[rndCur].width/2;
					ImagesArray[Num].images[rndCur].y = 530/2 - ImagesArray[Num].images[rndCur].height;
					break;
				case 7:
					for(i=0;i<ImagesArray.length;i++)
					{
						for(j=0;j<ImagesArray[i].images.length;j++)
						{
							ImagesArray[i].images[j].visible=true;
							ImagesArray[i].images[j].x=XMLObj.AllMoney.Money[i].Image[j].@xpos;
							ImagesArray[i].images[j].y=XMLObj.AllMoney.Money[i].Image[j].@ypos;
						}
					}
					break;
				default:
					break;
			}
		}
		private function DragIt(e:MouseEvent):void
		{
			var tar=e.currentTarget;
			DragObj=tar;
			setChildIndex(DragObj,numChildren-1);
			DragObj.startDrag(false,new Rectangle(0,0,sw-DragObj.width,sh-DragObj.height-105));
			DragObj.addEventListener(MouseEvent.MOUSE_UP,DropIt);
			stage.addEventListener(MouseEvent.MOUSE_UP,DropIt);
		}
		private function DropIt(e:MouseEvent):void
		{
			if(DragObj)
			{
				DragObj.removeEventListener(MouseEvent.MOUSE_UP,DropIt);
				stage.removeEventListener(MouseEvent.MOUSE_UP,DropIt);
				DragObj.stopDrag();
				DragObj=new MovieClip();
			}
		}
		private function randomRange(minNum:Number, maxNum:Number):Number  
		{  
			return (Math.floor(Math.random() * (maxNum - minNum + 1)) + minNum);  
		} 
		
	}
}