﻿package com
{
	import flash.display.MovieClip;
	import flash.display.Loader;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	
	import flash.events.Event;
	import flash.events.MouseEvent;
	
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.utils.getDefinitionByName;
	import flash.text.Font;
	public class OldManPoem extends MovieClip
	{
		private var XMLObj:XML=new XML();
		private var ImageLoadersArray:Array=new Array();
		private var CurrentIndex:Number=0;
		private var ImageIndex:Number=0;
		private var TotalPoems:Number;
		private var prevBtn:previous=new previous();
		private var nxtBtn:next=new next();
		private var ImageObj:MovieClip=new MovieClip();
			
		public function OldManPoem()
		{
			LoadActivityXML();
		}
		private function LoadActivityXML():void
		{
			var LoaderObj:URLLoader=new URLLoader();
			LoaderObj.load(new URLRequest("xml/poem.xml"));
			LoaderObj.addEventListener(Event.COMPLETE, onXMLLoaded);
		}
		private function onXMLLoaded(e:Event):void
		{
			XMLObj=XML(e.target.data);
			var Len:Number=XMLObj.Poems.Poem.length();
			TotalPoems=Len;
			addChild(ImageObj);
			LoadImages();
			//AddText();
			//AddNavigationButtons();
		}
		private function LoadImages(e:Event=null):void
		{

			if(ImageIndex<TotalPoems)
			{
				if(XMLObj.Poems.Poem[ImageIndex].@imageURL!=undefined && XMLObj.Poems.Poem[ImageIndex].@imageURL!="")
				{
					LoadImage(ImageIndex);
					//ImageIndex++;
					TotalPoems>1?ImageIndex++:ImageIndex=0
				}else
				{
					ImageLoadersArray.push(new Loader());
					//ImageIndex++;
					TotalPoems>1?ImageIndex++:ImageIndex=0
					LoadImages();
				}
			}
			if(ImageIndex==(TotalPoems-1))
			{
				reset_btn.addEventListener(MouseEvent.CLICK, onReset);
				AddText();
				AddNavigationButtons();
				AddImage()
			}
		}
		public function onReset(evt:MouseEvent = null ):void {
			
			CurrentIndex = 0;
			ImageIndex=0;
			AddText();
			AddImage();
			AddNavigationButtons();
			
		}
		private function LoadImage(ind:Number):void
		{
			var LoaderObj:Loader=new Loader();
			LoaderObj.load(new URLRequest(XMLObj.Poems.Poem[ind].@imageURL));
			LoaderObj.contentLoaderInfo.addEventListener(Event.COMPLETE,LoadImages);
			ImageLoadersArray.push(LoaderObj);
		}
		private function AddText():void
		{
			if(getChildByName("poem_txt"))
			{
				removeChild(getChildByName("poem_txt"));
			}
			var TxtFld:TextField=new TextField();
			TxtFld.name="poem_txt";
			TxtFld.autoSize="left";
			TxtFld.selectable=false;
			TxtFld.multiline=true;
			
			
			TxtFld.htmlText=XMLObj.Poems.Poem[CurrentIndex];
			TxtFld.antiAliasType=AntiAliasType.ADVANCED;
			
			var TF:TextFormat=new TextFormat();
			
			var FontC=getDefinitionByName(XMLObj.Poems.@FontId) as Class;
			var newFont:Font=new FontC();
			
			TF.font=newFont.fontName;	
			TF.size=XMLObj.Poems.@FontSize;
			//TF.color=XMLObj.Poems.@FontColor;

			TxtFld.setTextFormat(TF);	
			TxtFld.embedFonts=true;
			
			TxtFld.x=XMLObj.Poems.Poem[CurrentIndex].@xpos;
			TxtFld.y=XMLObj.Poems.Poem[CurrentIndex].@ypos;
			addChild(TxtFld);
		}
		private function AddImage():void
		{
			
			
			if(ImageObj.getChildByName("image"))
				{
					ImageObj.removeChild(ImageObj.getChildByName("image"));
				}
			if(ImageLoadersArray[CurrentIndex].content)
			{
				
				var im:MovieClip=new MovieClip();
				im.name="image";
				im.addChild(ImageLoadersArray[CurrentIndex].content);
				ImageObj.addChild(im);
				ImageObj.x=XMLObj.Poems.Poem[CurrentIndex].@imageX;
				ImageObj.y=XMLObj.Poems.Poem[CurrentIndex].@imageY;

			}
		}
		private function AddNavigationButtons():void
		{
			
			if(XMLObj.Poems.Poem.length()!=1){
				prevBtn.x=XMLObj.Buttons.Previous.@xpos;
				prevBtn.y=XMLObj.Buttons.Previous.@ypos;
				nxtBtn.x=XMLObj.Buttons.Next.@xpos;
				nxtBtn.y=XMLObj.Buttons.Next.@ypos;
				addChild(prevBtn);
				addChild(nxtBtn);
				prevBtn.addEventListener(MouseEvent.CLICK,navPrevious);
				prevBtn.alpha=0.5;
				prevBtn.mouseEnabled=false;
				nxtBtn.alpha=1;
				nxtBtn.mouseEnabled=true;
				nxtBtn.addEventListener(MouseEvent.CLICK,navNext);
			}
		}
		private function navPrevious(e:MouseEvent):void
		{
			if(CurrentIndex>0)
			{
				CurrentIndex--;
				AddText();
				AddImage();
			}
			if(CurrentIndex==0)
			{
				prevBtn.alpha=0.5;
				prevBtn.mouseEnabled=false;
			}
			
			nxtBtn.alpha=1;
			nxtBtn.mouseEnabled=true;
		}
		private function navNext(e:MouseEvent):void
		{
			if(CurrentIndex<(TotalPoems-1))
			{
				CurrentIndex++;
				AddText();
				AddImage();
			}
			if(CurrentIndex==(TotalPoems-1))
			{
				nxtBtn.alpha=0.5;
				nxtBtn.mouseEnabled=false;
			}
			prevBtn.alpha=1;
			prevBtn.mouseEnabled=true;
		}
	}
}